; Mp3 Player Control Program for iso CD ( ATAPI drive)
; Ext SRAM version , CDROM iso 9660 version ( +joliet)
; (C) 1999 Arne Hennig,last edited 20 12 1999
; Pouzit PATCH je na adrese 0x1000 v ext.EEPROM & zakazany zapis
;.device  AT90S8515         v2708!,upraven bufftest&skip,STA swreset
.include "8515def.inc"      ;     ,zrusen plist+nevyuzite flagy

.EQU EXTBUFFERSIZE = 18*1024         ; Sound Buffer, x * 256 Bytes   x=32
.EQU STACKTOP      = 0x80-1          ; Stack in int.RAM
     .DSEG
     .ORG 0x80
v_INTBUFF:       .BYTE           256 ; LOW Buffer
v_INPOS:         .BYTE           2   ; Data  Input  Addr
v_OUTPOS:        .BYTE           2   ; Data  Output Addr
v_TRACKSIZE:     .BYTE           4   ; Track size in sectors
v_TRACKSIZEB:    .BYTE           4   ; Track size in bytes
v_TRACKNUM:      .BYTE           2   ; Track number
v_TRACKNEXT:     .BYTE           2   ; next track
v_TRACKSTART:    .BYTE           4   ; track start ( abs sectors )
v_TRACKEND:      .BYTE           4   ; track end ( abs sectors )
v_PLAYTRACKCOUNT:.BYTE           2   ; num of tracks to play(Plist and normal)
v_PLAYMODE:      .BYTE           1
v_TRACKCOUNT:    .BYTE           2   ; Number of Tracks
v_PATHCOUNT:     .BYTE           2   ; Count of Path refs
v_PATHTABLEaddR: .BYTE           4   ; Sector for Path table
v_TRACKPTR:      .BYTE           2   ; Track tab pt
v_PATHPTR:       .BYTE           5   ; 2 OFS,3 SECTOR
v_PATHaddR:      .BYTE           4   ; Byte Pos absolute
v_DIRPTR:        .BYTE           5   ; 2 OFS,3 SECTOR
v_DIRaddR:       .BYTE           4   ; Byte Pos absolute
v_DIRSIZE:       .BYTE           3   ; size(end) of dir( sects )
v_Temp:          .BYTE           8   ; Temp  Vars
v_VolumeIndex:   .BYTE           1   ; Index into Volume Table
v_FaderIndex:    .BYTE           1   ; Balance delta
v_BassIndex:     .BYTE           1
v_TrebleIndex:   .BYTE           1
v_PitchIndex:    .BYTE           1
v_UARTCount:     .BYTE           1   ; UART tx Count
v_UARTAddr:      .BYTE           2   ; UART tx addr
v_UARTOutPreBuff:.BYTE           1   ; for some  str tx
v_UARTOutBuff:   .BYTE           40  ; UART Tx buffer
v_UARTInBuff:    .BYTE           16  ; UART Rx buffer
v_UARTTemp:      .BYTE           4
v_UARTInCount:   .BYTE           1   ; UART Incoming data size
v_UARTjmp:       .BYTE           2
v_ui_event:      .BYTE           1
v_ui_cmdold:     .BYTE           1
v_PATHSIZE:      .BYTE           5
v_I2CDataAddr:   .BYTE           2
v_I2CDataSize:   .BYTE           1
BP0:             .BYTE           1   ; packet command
BP1:             .BYTE           1
BP2:             .BYTE           1
BP3:             .BYTE           1
BP4:             .BYTE           1
BP5:             .BYTE           1
BP6:             .BYTE           1
BP7:             .BYTE           1
BP8:             .BYTE           1
BP9:             .BYTE           1
BP10:            .BYTE           1
BP11:            .BYTE           1
DA_MODE:         .BYTE           2   ; Sub channel info (CDDA)
STATUS_R:        .BYTE           1   ; ATA registers
STATUS_A:        .BYTE           1
COMMAND:         .BYTE           1
CILYNDER_H:      .BYTE           1
CILYNDER_L:      .BYTE           1
SECTOR_N:        .BYTE           1
SECTOR_C:        .BYTE           1
DEVICE_H:        .BYTE           1
FEATURES:        .BYTE           1
DEVICE_C:        .BYTE           1
DA_COMMAND:      .BYTE           3   ; Skip table & pause/unpause mode & EJ/LO
LEAD_OUT_M:      .BYTE           1   ; Lead Out CDDA(end of last track)
LEAD_OUT_S:      .BYTE           1
LEAD_OUT_F:      .BYTE           1
END_M:           .BYTE           1   ; end of actual track
END_S:           .BYTE           1
END_F:           .BYTE           1
START_M:         .BYTE           1   ; Start pos. actual track
START_S:         .BYTE           1
START_F:         .BYTE           1
ACT_TRACK:       .BYTE           1   ; DA Trackcount
FIRST_TRACK:     .BYTE           1   ; CDDA
LAST_TRACK:      .BYTE           1   ; CDDA
POS_M:           .BYTE           1   ; Actual track pos.
POS_S:           .BYTE           1   ; for UI timer
LEN_M:           .BYTE           1   ; DA length
LEN_S:           .BYTE           1   ; for DA displaytime
DA_TRACK:        .BYTE           1   ; CD contains audio track
; CD ROM extensions -

       .ORG 0x260
v_TrackTable:      .BYTE         1024*6   ;     6K -> 512 Tracks  max.
v_BufferA:         .BYTE         2048     ;     2K
v_BufferB:         .BYTE         2048     ;     2K
v_TrackInfo:       .BYTE         1024     ;     1K
v_UI_ScrollOfs:    .BYTE         1
V_UI_LastTxt:      .BYTE         2
v_UI_TrackStr:     .BYTE         8
v_ui_state:        .BYTE         1
v_ui_tracksel:     .BYTE         2     ; track selection
v_ui_timemode:     .BYTE         1     ; time display mode
v_ui_mappingcount: .BYTE         1
v_ui_mode:         .BYTE         1
v_ui_skipcount:    .BYTE         1     ; +-1,+-10,BIG +-50
v_ui_bitrate:      .BYTE         1     ; Average Bitrate
v_ui_displaymode:  .BYTE         1
v_ui_ircount:      .BYTE         1
v_ui_ircmd:        .BYTE         2
v_ui_ircmdold:     .BYTE         2
v_ui_zSave:        .BYTE         2
v_ui_displaymode_old:.BYTE       2     ; saves modes of level 0(normal) and 1(tracksel,...)
v_ui_displaylevel: .BYTE         1     ; display menu level
v_ui_displaytime:  .BYTE         2
v_ui_lighttime:    .BYTE         1
v_ui_irmap:        .BYTE         64   ; 32 prikazu  v eeprom
v_ui_staticStrs8:  .BYTE         160  ; 20 static 8 char info  strings z eeprom!
v_ui_staticStrs16: .BYTE         320  ; 20 static 16 char info strings  -"-
v_ui_mappinginfo:  .BYTE         16

EXTBUFFSTART:  .BYTE           EXTBUFFERSIZE
EXTBUFFEND:    ;END
dempty:            .byte       1

.EQU mcucrRAM            = 0x8F          ; mcucr for RAM access
.EQU mcucrHD             = 0x0F          ; mcucr for HD (CD) access
.EQU o_Size              = 0             ; Field Addrs for Track Info
.EQU o_PathName          = 4             ; Path Name
.EQU o_FileName          = o_PathName    + 129
.EQU o_FilePath          = o_FileName    + 129
.EQU o_Flags             = o_FilePath    + 129
.EQU o_Name              = o_Flags       + 1
.EQU o_Artist            = o_Name        + 30
.EQU o_Album             = o_Artist      + 30
.EQU o_Year              = o_Album       + 30
.EQU o_Comment           = o_Year        + 4
.EQU o_Genre             = o_Comment     + 30
.EQU o_ByteSize          = o_Genre       + 1
.EQU o_NameSize          = o_ByteSize    + 4
.EQU o_ArtistSize        = o_NameSize    + 1
.EQU o_AlbumSize         = o_ArtistSize  + 1
.EQU o_CommentSize       = o_AlbumSize   + 1
.EQU o_Reserved          = o_CommentSize + 1
.EQU C_BAUD              = 34      ; ( 51 = 9600Bps for 8Mhz 34=14400)
.EQU C_EXTEEaddR         = 0xA0    ; EEPROM Addr I2C  1010 0000 B
.EQU pm_normal           = 0       ; A0,A1,A2 = 0
.EQU pm_repeat           = 1
.EQU pm_repeat1          = 2
.EQU ui_timerval         = 62000
.EQU Bsy                 = 7       ; Status reg bit
.EQU Drdy                = 6
.EQU Drq                 = 4
.EQU Demand              = 3
.EQU CntrlLatch          = 1
.EQU HD_Mem              = 2
.EQU RD                  = 7
.EQU WR                  = 6
.EQU PD_RESET            = 5       ; Port D, ATAPI Reset

; NEW ATA-5 Commands
.EQU CmdReg       = 0x17
.EQU CountHReg    = 0x15
.EQU CountLReg    = 0x14
.EQU DataReg      = 0x10
.EQU DevCntrlReg  = 0x0E
.EQU AltStatReg   = 0x0E
.EQU DevHeadReg   = 0x16
.EQU ErrReg       = 0x11
.EQU FeatReg      = 0x11
.EQU IntReasonReg = 0x12
.EQU TagReg       = 0x13
.EQU StatReg      = 0x17

.EQU D_STATUS     = 0B00010111
.EQU D_STATUS_A   = 0B00001110
.EQU D_COMMAND    = 0B00010111
.EQU D_CILYNDER_H = 0B00010101
.EQU D_CILYNDER_L = 0B00010100
.EQU D_SECTOR_N   = 0B00010011
.EQU D_SECTOR_C   = 0B00010010
.EQU D_DEVICE_H   = 0B00010110
.EQU D_FEATURES   = 0B00010001
.EQU D_ERRORR     = 0B00010001
.EQU D_DATA_R     = 0B00010000
.EQU D_DEVICE_C   = 0B00001110

;      < Flag values >
;.EQU f_Cdready     = 0   ;
.EQU f_spitransfer = 1   ; transfering Data
.EQU f_demand      = 2   ; data request
.EQU f_IdpTrans    = 3   ; non mp3 data ransfer flag (do not change mp3 data buffers )
.EQU f_XferDone    = 4   ; CD transfer ok
.EQU f_txRunning   = 5   ; tx in process
.EQU f_CmdWaiting  = 6   ; Command execution is waiting for data
.EQU f_joliet      = 7   ; use joliet file system
.EQU f_ui_uart     = 0
.EQU f_ui_timer    = 1
;      < State Flag values >
.EQU fs_Play       = 0   ; System is playing
;.EQU fs_NoDisc    = 1   ;
.EQU fs_hwreset    = 2   ;
.EQU fs_DirFirst   = 3   ; loadindg  1st dir enty (current dir)
.EQU fs_Round      = 4   ; round up sector
.EQU ERR           = 5   ; error in status reg.(ATA)
.EQU fs_eject      = 6   ; 1=EJECT,0=LOAD
.EQU fs_Autrack    = 7   ; Audio track

;      < I2C   Defs >

.EQU SCLP          = 0   ; SCL Pin number (port  D)
.EQU SDAP          = 3   ; SDA Pin number (port  D)
.EQU b_dir         = 0   ; transfer direction bit in i2cadr(write!)
.EQU i2crd         = 1   ; I2C read    ; fclk ~ 36kHz
.EQU i2cwr         = 0   ; I2C write

;      < Register definitions >
.DEF PMreg         = r0
.DEF A0            = r1
.DEF A1            = r2
.DEF A2            = r3
.DEF A3            = r4
.DEF IntTemp       = r5
.DEF rezreg        = r6   ;rezerva
.def drem24uL      = r19
.def drem24uM      = r20
.def drem24uH      = r21
.def dres24uL      = r16
.def dres24uM      = r17
.def dres24uH      = r18
.def dd24uL        = r16
.def dd24uM        = r17
.def dd24uH        = r18
.def dv24uL        = r7
.def dv24uM        = r8
.def dv24uH        = r9
.def mc8u          = r16  ;multiplicand
.def mp8u          = r17  ;multiplier
.def m8uL          = r17  ;result Low byte
.def m8uH          = r18  ;result High byte
.DEF BufferDSizeL  = r10
.DEF BufferDSizeH  = r11
.DEF rezreg2       = r12  ;rezerva
.DEF Null          = r13
.DEF One           = r14
.DEF FF            = r15
.DEF temp1         = r16
.DEF temp2         = r17
.DEF temp3         = r18
.DEF temp4         = r19
.DEF temp5         = r20
.DEF temp6         = r21
.DEF WordCount     = r25
.DEF delayL        = r20
.DEF delayH        = r21
.DEF i2cdelay      = r18  ; Delay loop variable
.DEF i2cdata       = r19  ; I2C data transfer register
.DEF i2cadr        = r20  ; I2C address and direction register
.DEF i2cstat       = r21  ; I2C bus status register
.DEF UARTTemp      = r22
.DEF SPITemp       = r22
.DEF Flags         = r23
.DEF StateFlags    = r24
.DEF dcnt24u       = r25
.DEF xAddrL        = r26  ; X  reg
.DEF xAddrH        = r27  ; X  reg
.DEF yAddrL        = r28  ; Y  reg
.DEF yAddrH        = r29  ; Y  reg
.DEF zAddrL        = r30  ; Z  reg
.DEF zAddrH        = r31  ; Z  reg

     .CSEG
     .ORG 0
       rjmp RESET
       rjmp INT_0
       rjmp INT_1
       rjmp TIMER1
       rjmp TIMER1
       rjmp TIMER1
       rjmp TIMER1
       rjmp TIMER0
       rjmp SPI_INT
       rjmp UART_RX
       reti
       rjmp UART_TX
       reti

UART_TX:in   Inttemp,SREG
       lds   UARTTemp,v_UARTCount
       tst   UARTTemp
       breq  UART_TX_EE
       dec   UARTTemp
       sts   v_UARTCount,UARTTemp
       lds   xAddrL,v_UARTAddr
       lds   xAddrH,v_UARTAddr+1
       ld    UARTTemp,x+
       sts   v_UARTAddr,xAddrL
       sts   v_UARTAddr+1,xAddrH
       cbi   UCR,TXB8
       out   UDR,UarTTemp
       nop
UART_TX_E:out  SREG,inttemp
       reti

UART_TX_EE:cbr  Flags,1<<f_txRunning
       out   SREG,inttemp
       reti

UART_RX:in   inttemp,SREG
       sbis  UCR,RXB8           ; 1.byte ma RXB8=1
       rjmp  UART_RX_1          ; dalsi RXB8=0
       sts   v_UARTInCount,Null
       cbr   Flags,1<<f_CmdWaiting
UART_RX_1:lds  UARTtemp,v_UARTInCount
       cpi   UARTtemp,16        ;16   commands count
       brsh  UART_RX_E2
       ldi   xAddrL,v_UARTInBuff
       ldi   xAddrH,v_UARTInBuff>>8
       add   xAddrL,UARTtemp
       adc   xAddrH,Null
       inc   UARTTemp
       sts   v_UARTInCount,UARTTemp ;pocet prikazu
       in    UARTTemp,UDR      ; !
       st    x,UARTtemp
       lds   UARTTemp,v_ui_event
       sbr   UARTTemp,(1<<f_ui_uart)
       sts   v_ui_event,UARTTemp
UART_RX_E:out  SREG,inttemp
       reti

UART_RX_E2:in UARTtemp,UDR
       nop
       out   SREG,inttemp
       reti

UART_RX_EST:in  UARTTemp,UDR
       sts   v_UARTInCount,Null
       out   SREG,inttemp
       reti

INT_1: in    inttemp,SREG        ; Req. od STA !!!
       sbr   Flags,(1<<f_demand) ; data req. int
       out   SREG,inttemp
       reti

INT_0: ;in   inttemp,sreg
       ;sbr  flags,(1<<f_cdready)
       ;out  sreg,inttemp
       reti

TIMER1:in   inttemp,SREG ; 452,61 msec
       ldi  UARTTemp,HIGH(ui_timerval)
       out  TCNT1H,UARTTemp
       ldi  UARTTemp,LOW(ui_timerval)
       out  TCNT1L,UARTTemp
       lds  UARTTemp,v_ui_event
       sbr  UARTTemp,1<<f_ui_timer
       sts  v_ui_event,UARTTemp
TIMER1_E:out  SREG,inttemp
TIMER0:reti

SPI_INT:in  inttemp,SREG
SPI_CALL:sbis PIND,demand            ; if STA want data,send
       rjmp SPI_INT_DE               ; end block
       sbr   Flags,(1<<f_spitransfer)
       cp    BufferDSizeL,Null
       cpc   BufferDSizeH,Null
       brne  SPI_INT_DATA
       cbr   Flags,(1<<f_spitransfer)
       sbr   Flags,(1<<f_demand)     ; ! "STA INT"
       rjmp  SPI_INT_E
SPI_INT_DATA:ld  SpiTemp,Y+
       out   SPDR,SpiTemp
       sub   BufferDsizeL,One
       sbc   BufferDsizeH,Null
       cpi   yAddrL,EXTBUFFEND
       brne  SPI_INT_E
       cpi   yAddrH,EXTBUFFEND>>8
       brne  SPI_INT_E
       ldi   yAddrH,EXTBUFFSTART>>8
       ldi   yAddrL,EXTBUFFSTART
SPI_INT_E:out  SREG,inttemp
       reti

SPI_INT_DE:cbr  Flags,(1<<f_spitransfer)|(1<<f_demand)
       out   SREG,inttemp
       reti

WAIT:  push  temp5    ; T = temp1 * 25msec
       push  temp6
       clr   delayH
       clr   delayL
WAIT1: dec   delayL
       brne  WAIT1
       dec   delayH
       brne  WAIT1
       dec   temp1
       brne  WAIT1
       pop   temp6
       pop   temp5
       ret

INITBUFF:mov BufferDSizeL,Null
       mov   BufferDSizeH,Null
       ldi   temp1,EXTBUFFSTART
       mov   yAddrL,temp1
       sts   v_INPOS,temp1
       sts   v_OUTPOS,temp1
       ldi   temp1,EXTBUFFSTART>>8
       mov   yAddrH,temp1
       sts   v_INPOS+1,temp1
       sts   v_OUTPOS+1,temp1   ;init mp3 data buffer
       ret

CDsel: out   PORTA,Null
       out   PORTC,Null
       out   DDRA,Null
       out   DDRC,Null
       sbi   PORTB,HD_Mem       ; Sel RAM(0) - HD(1)
       push  temp1
       ldi   temp1,mcucrHD
       out   MCUCR,temp1
       sbi   portd,wr           ; ! Disable  !    R/W
       sbi   portd,rd
       cbi   PORTB,CntrlLatch   ; Addr   / Data Mux
       pop   temp1
       ret

RAMsel:push  temp1
       ldi   temp1,mcucrRAM
       cbi   PORTB,CntrlLatch   ; Addr   / Data Mux
       out   MCUCR,temp1
       cbi   PORTB,HD_Mem       ; Sel RAM(0) - HD(1)
       pop   temp1
       ret

.macro UartOn
       ldi   temp1,0xDC
       out   UCR,temp1
       nop
       out   USR,FF
.endm

RESET: ldi   temp1,STACKTOP   ; Load and
       out   SPL,temp1        ; Set Stack Pointer
       clr   Null
       out   SPH,Null
       cli
       ldi   temp1,20
       rcall wait
       out   GIMSK,Null       ; Disable  INT0 & INT1
       ser   temp1
       mov   FF,temp1
       ldi   temp1,1
       mov   One,temp1
       ldi   temp1,0xB6
       out   DDRB,temp1
       ldi   temp1,0x00
       out   PORTB,temp1
       out   DDRA,Null
       out   DDRC,Null
       ldi   temp1,0xE0
       out   DDRD,temp1
       out   PORTD,temp1
       ldi   temp1,0B11000000   ;
       out   GIMSK,temp1
       rcall RAMsel             ; enable RAM interface
       out   TIMSK,Null         ; disable Timer INTs
       cbi   PORTD,PD_RESET     ; send RESET to CD
       ldi   xAddrL,0x80        ; start RAM
       ldi   xAddrH,0x80>>8     ;
       mov   yaddrL,xaddrL      ; RAM counter
       ldi   yaddrH,0xff
clsRAM:st    x+,Null            ; clear RAM
       sbiw  yaddrl,1
       brne  clsRAM
       sbi   PORTD,PD_RESET     ; HW Reset CD end (~50msec)
       sbr   stateflags,1<<fs_hwreset
; patch upd   !
       ldi   xAddrL,EXTBUFFSTART
       ldi   xAddrH,EXTBUFFSTART>>8
       rcall i2c_init
       ldi   i2cadr, C_EXTEEaddR+i2cwr     ;eeprom sel
p22:   rcall i2c_start
       brcs  p22
       ldi   i2cdata,4096>>8    ; OD ADRESY 4096 JE PATCH (4016 Byte)
       rcall i2c_write          ; DELKA JE DANA PRVNIMI 2 BYTY
       ldi   i2cdata,4096
       rcall i2c_write
       rcall i2c_stop
       ldi   i2cadr, C_EXTEEaddR+i2crd
       rcall i2c_start
       clc
       rcall i2c_read
       mov   zAddrL,i2cdata     ; PRVNI DVA BYTY UDAJI POCET
       st    x+,i2cdata         ; LOW BYTE JAKO PRVNI   !!
       clc
       rcall i2c_read           ; patch z EEPROM do RAM
       mov   zAddrH,i2cdata
       st    x+,i2cdata
p2:    clc
       rcall i2c_read
       st    x+,i2cdata
       clc
       rcall i2c_read
       st    x+,i2cdata
       sbiw  zAddrL,1
       brne  p2
       sec
       rcall i2c_do_transfer
       rcall i2c_stop
       ldi   xAddrL,EXTBUFFSTART ; POSLE PATCH z RAM do STA
       ldi   xAddrH,EXTBUFFSTART>>8
       ld    zAddrL,x+
       ld    zAddrH,x+
       rcall i2c_init
p3:    ldi   i2cadr,0x86+i2cwr   ; KAZDY DVOJPRIKAZ ZVLAST !
       rcall i2c_start
       ld    i2cdata,x+
       cpi   i2cdata,0x10        ; SOFT RESET STA013   !
       brne  p3a
       rcall i2c_do_transfer     ; send reset
       ld    i2cdata,x+
       rcall i2c_do_transfer
       rcall i2c_stop
       clr   rezreg
       ldi   wordcount,10        ; wait 1 msec & continue...
p3aa:  dec   rezreg
       brne  p3aa
       dec   wordcount
       brne  p3aa
       rjmp  p3b
p3a:   rcall i2c_do_transfer
       ld    i2cdata,x+
       rcall i2c_do_transfer
       rcall i2c_stop
p3b:   sbiw  zAddrL,1
       brne  p3
       rcall LoadEEText
       ldi   temp1,C_BAUD
       out   UBRR,temp1          ; Set UART Baud Rate
       rcall INITBUFF
       ldi   temp1,1
       rcall Wait
       rcall i2c_init
       ldi   zAddrL,I2Cseq_INIT_EE  ; START_SEQ in EEPROM  8515
       ldi   zAddrH,I2Cseq_INIT_EE>>8
       rcall STA_EEseqW             ; poslat do STA
       ldi   temp1,0xF0
       out   DDRD,temp1
       clr   Flags
       clr   StateFlags
       out   PORTD,temp1
;      cbi   portd,4             ; MP3 ->  STA
       ldi   temp1,8            ; -8 dB
       sts   v_VolumeIndex,temp1
       rcall VolSet              ; I2C seq. do  STA
;      ldi   temp1,3
;      sts   v_bassindex,temp1
;      sts   v_trebleindex,temp1
       rcall cmd_bass_up         ; + 1.5dB
       rcall cmd_treble_up       ; + 1.5dB
       sts   v_ui_skipcount,One  ; No of skips (1)
       ldi   temp1,pm_normal
       sts   v_PlayMode,temp1
       in    temp1,SPSR
       ldi   temp1,0xD4          ; D5
       out   SPCR,temp1          ; enable SPI
       sts   DA_COMMAND+1,One    ; Pause/unpause CDDA
       ldi   temp1,0xA0
       sts   COMMAND,temp1       ; ATA Packet command
      ;sts   FEATURES,Null
      ;sts   SECTOR_C,Null       ; Ini  ATA reg.
      ;sts   SECTOR_N,Null
       sts   CILYNDER_L,FF
       ldi   temp1,0x80
       sts   CILYNDER_H,temp1    ; Bytecounter limit ATA
      ;sts   DEVICE_H,Null
       sei
       sbr   Stateflags,(1<<fs_eject); EJECT ready !!
       sbr   Stateflags,(1<<fs_play); PLAY ready !!
MainWaitReady:
    UARTon
       rcall UI_init

INI_CD:sts   da_track,null          ; mark CD as a data CD
       rcall CDSel
       ldi   temp1,40               ; 1sec wait
       rcall WAIT
       rcall INI_ATAPI
       rcall TEST_UNIT_READY ;
       sbrs  Stateflags,err
       rjmp  INI_CD2                ; If no error,read TOC
ini_3: rcall ramsel
       ldi   zaddrL,mel_NO_CD       ; No CD message.
       ldi   zaddrH,mel_NO_CD>>8
       rcall SEND_MEL
       lds   temp1,v_uartinbuff+1   ; wait for EJECT command
       cpi   temp1,15
       brne  ini_cd
       rcall cdsel
       rcall mp3_EJECT              ; EJECT CD
     ; rjmp  INI_CD

SEND_MEL:
       rcall ramsel
       ldi   yaddrL,v_UARTOUTBUFF   ; Send data for display
       ldi   yaddrH,v_UARTOUTBUFF>>8
       ldi   temp2,32
wr_seQ:rcall EEREAD
       st    y+,pmreg               ; Data EEPROM->Tx Buffer
       adiw  zaddrL,1
       dec   temp2
       brne  wr_seQ
       ldi   temp1,32               ; 32 byte$ send
       sts   v_UARTCount,temp1
       sbi   UCR,TXB8               ; Flag byte
       out   UDR,temp1
       cbi   UCR,TXB8
       ldi   yaddrL,v_UARTOUTBUFF
       ldi   yaddrH,v_UARTOUTBUFF>>8
uart_addtx:
       sbis  usr,udre
       rjmp  uart_addtx
       ld    temp2,y+
       out   udr,temp2
       dec   temp1                  ; 32 x repeat
       brne  uart_addtx
       ldi   temp1,20               ; pause before next data transfer(s)
       rcall wait                   ; Tx ~26msec/14400Bd
       ret

INI_CD2:sbr  Stateflags,(1<<fs_Autrack)
       sts   BP4,One
       rcall ST_UNIT                ; Start UNIT & read TOC command
       sbrc  Stateflags,err
       rjmp  INI_3                  ; ! if NOT! CD loaded wait
       ldi   zaddrL,mel_CD_Load     ; Send CD Load message...
       ldi   zaddrH,mel_CD_Load>>8
       rcall SEND_MEL
       rcall cdsel
       ldi   temp1,2
       sts   BP1,temp1              ; TOC MSF mode
       ldi   temp1,0xAA             ; Read Lead Out
       sts   BP6,temp1
       rcall READ_TOC
       rcall RD_DATA_R
       rcall RD_DATA_R
       sts   ACT_TRACK,temp1
       sts   FIRST_TRACK,temp1
       sts   LAST_TRACK,temp2
       sts   v_playtrackcount,temp2 ; No of tracks for UI
       sts   v_trackcount,temp2
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       sts   LEAD_OUT_M,temp2       ; CD end area
       rcall RD_DATA_R
       sts   LEAD_OUT_S,temp1
       sts   LEAD_OUT_F,temp2
       ldi   temp1,20               ; 0,5 sec wait
       rcall WAIT
GET_TOC:rcall cdsel
       lds   temp1,ACT_TRACK
       sts   v_tracknum,temp1       ; No of act.track for UI
       sts   BP6,temp1
       ldi   temp1,2
       sts   BP1,temp1
       rcall READ_TOC
       rcall RD_DATA_R
       rcall RD_DATA_R
       ;temp2=control
       rcall RD_DATA_R ;temp1=TNO
       andi  temp2,0b00000100       ; Audio test
       breq  TOC_3
       cbr   Stateflags,(1<<fs_Autrack)
TOC_3: sts   DA_MODE,One
       rcall RD_DATA_R
       rcall RD_DATA_R
       sts   START_M,temp2          ; Actual track
       rcall RD_DATA_R
       sts   START_S,temp1
       sts   START_F,temp2
       sbrs  Stateflags,fs_Autrack
       rjmp  DATA_CD                ; if there is any data track,jump
       lds   temp1,ACT_TRACK
       lds   temp2,LAST_TRACK
       cp    temp1,temp2
       breq  LEAD_OUT               ; Last track
       inc   temp1                  ; Auto Inc
       sts   ACT_TRACK,temp1
       sts   BP6,temp1
       ldi   temp1,2
       sts   BP1,temp1
       rcall READ_TOC
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       sts   BP6,temp2
       sts   END_M,temp2            ; for UI
       rcall RD_DATA_R
       sts   BP7,temp1
       sts   END_S,temp1
       sts   BP8,temp2
       lds   temp1,START_M          ; (for actual track)
       sts   BP3,temp1
       lds   temp1,START_S
       sts   BP4,temp1
       lds   temp1,START_F
       sts   BP5,temp1
       rjmp  PLAY_A

LEAD_OUT:lds temp1,START_M          ; Last track
       sts   BP3,temp1
       lds   temp1,START_S
       sts   BP4,temp1
       lds   temp1,START_F
       sts   BP5,temp1
       lds   temp1,LEAD_OUT_M       ; Lead Out
       sts   BP6,temp1
       sts   END_M,temp1
       lds   temp1,LEAD_OUT_S
       sts   BP7,temp1
       sts   END_S,temp1
       lds   temp1,LEAD_OUT_F
       sts   BP8,temp1
       inc   temp1                  ; Auto   Inc
       sts   ACT_TRACK,temp1

PLAY_A:sts   DA_TRACK,FF            ; Mark DA track (for Hybrid CD)
       sts   DA_MODE+1,FF
;       sbi   portd,4                ; ANALOG  MODE
       rcall ramsel
       rcall ui_trackchangeproc     ; Track No->DISPLAY
       rcall cdsel
       sbrc  Stateflags,fs_play
       rcall PLAY_AUDIO_MSF
PL_WAIT:
       rcall cdsel
       sbr   Stateflags,(1<<fs_Autrack)
       sbrc  Stateflags,fs_play
       rcall READ_SUB
       lds   temp1,v_ui_event
       cpse  temp1,null
       rjmp  UIProcx
PL_WAITx:lds   temp1,DA_MODE+1
       cpi   temp1,0x00            ; STOP Play
      ; breq  PL_WAIT1
       lds   temp1,DA_MODE
       cpi   temp1,0x11            ;play in progress
       breq  PL_WAIT
      ; cpi   temp1,0x13           ;play completed
      ; brne  PL_WAIT
       cpi   temp1,0x12            ;play paused
       breq  PL_WAIT
       rjmp  DA_FORWARD

PL_WAIT1:rcall ramsel
       ldi   zaddrL,mel_CD_Stop     ; send CD_stop mess.
       ldi   zaddrH,mel_CD_Stop>>8
       rcall SEND_MEL
       rjmp  PL_WAIT

UIProcx:rcall ramsel
       rcall UIProc
       rcall cdsel
       lds   temp1,DA_COMMAND
       cpi   temp1,0                ; None command
       breq  PL_WAITx               ; (for CDDA skip table)
       cpi   temp1,9
       brsh  PL_WAITx
       dec   temp1
       ldi   zaddrl,CD_DA_table
       ldi   zaddrH,CD_DA_table>>8
       add   zaddrl,temp1
       adc   zaddrh,null
       sts   DA_COMMAND,Null
       sts  v_uartinbuff,null
       ijmp                         ; COMMMAND 0 = EMPTY!!
CD_DA_table:                        ; SKIP table for UI
       rjmp  DA_PLAY                ; Command = UI_command code - 1!
       rjmp  DA_PAUSE               ; pause/unpause
       rjmp  DA_STOP                ; & reset count.
       rjmp  DA_BACKWARD            ; Track - 1
       rjmp  DA_FORWARD             ; Track + 1
       rjmp  DA_EJECT               ; CD
       rjmp  DA_LOAD                ; NONE!
       rjmp  DA_REPEAT              ; (Track)

DA_REPEAT:rcall cdsel
      rcall  Stop_play
      lds    temp1,ACT_TRACK
      dec    temp1
      sts    ACT_TRACK,temp1
      rjmp   GET_TOC

DA_FORWARD:rcall cdsel
      rcall  Stop_play
      lds    temp1,ACT_TRACK
      lds    temp2,LAST_TRACK
      dec    temp1
      cp     temp1,temp2
      brsh   DA_STOP
      rjmp   GET_TOC

DA_BACKWARD:rcall cdsel
      rcall  Stop_play
      lds    temp1,ACT_TRACK
      lds    temp2,FIRST_TRACK
      dec    temp1
      cp     temp1,temp2
      brne   DA_B1
      rjmp   INI_CD                 ; Track -1
DA_B1:subi   temp1,2
      sts    ACT_TRACK,temp1
      rjmp   GET_TOC

DA_STOP:rcall cdsel
      rcall  stop_play
      cbr    Stateflags,(1<<fs_play)
      rcall  ST_UNIT                ; Stop CD &
      sts    DA_MODE+1,null         ; stop ! Read Subchannel
      lds    temp1,FIRST_TRACK      ; reset track count.
      sts    ACT_TRACK,temp1
      rjmp   pl_wait                ; wait for start / eject

DA_PAUSE:rcall cdsel
      lds    temp1,DA_COMMAND+1
      sts    BP8,temp1
      rcall  PAUSE_RESUME
      lds    temp1,DA_COMMAND+1
      cp     temp1,One
      breq   DA_PAUSE1
      sts    DA_COMMAND+1,One       ; PAUSE
      rjmp   PL_WAIT
DA_PAUSE1:sts DA_COMMAND+1,null     ; UNPAUSE
      sbr    StateFlags,(1<<fs_Play)
      rjmp   PL_WAIT

DA_EJECT:rcall cdsel
      rcall  Stop_play
      rcall  MP3_Eject              ; wait new  cd

DA_LOAD:rcall  CDsel
      sbr    StateFlags,(1<<fs_eject)
      ldi    temp1,0b00000011       ; load disc
      sts    BP4,temp1
      rcall  ST_UNIT
      rjmp   ini_cd                 ; wait for TOC etc..

DA_PLAY:rcall cdsel
     rcall  Stop_play
     sbr    Stateflags,(1<<fs_play)
     sts    DA_MODE,One
     rjmp   INI_CD                  ; Start & play CD

;**************************************************************************
; MP3 part
DATA_CD:
;      cbi   portd,4                ; MP3 ->  STA
       rcall RAMSel

    uartON
       rcall UI_Init                ; init user if
       sbrs  stateflags,fs_hwreset  ; init jen po HW resetu
       rjmp  rsskip
       ldi   temp1,0x0B             ; autoload display!
       sts   v_uartinbuff+1,temp1
       rcall uiproc_1
rsskip:lds   temp1,DA_TRACK         ; if CD had an audio track
       cpse  temp1,null             ; & data track, there is a
       rjmp  DA_STOP                ; Hybrid CD,No search MP3
       sts   DA_TRACK,Null          ; & Reset for next CD
       sbr   StateFlags,(1<<fs_Play); Autoplay CD
MainWaitReady2:
       rcall CDSel
       sts   BP2,one
       rcall READ_TOC               ; Read TOC in mode 1
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       sts   bp6,temp1              ; first track in last sess.
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall READ_TOC               ; TOC in mode 0
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       rcall RD_DATA_R
       mov   a3,temp1               ; Start address of first track
       mov   a2,temp2               ; of the last complete session
       rcall RD_DATA_R              ; 8020i Atapi
       mov   a1,temp1
       mov   a0,temp2
       ldi   temp1,17               ; joliet test as 1.
       add   A0,temp1
       adc   A1,Null
       adc   A2,Null
       adc   A3,Null
       sts   v_TrackCount,Null
       sts   v_TrackCount+1,Null
       ldi   temp1,v_TrackTable
       sts   v_TrackPtr,temp1
       ldi   temp1,v_TrackTable>>8
       sts   V_TrackPtr+1,temp1
ReadTOC_8:
       rcall SET_MAX_SPEED        ; init  2x Speed
       ldi   temp6,0x40           ; Test sector counter
test3: push  temp6
       ldi   temp1,v_BufferA
       ldi   temp2,v_BufferA>>8
       rcall CD_XferData
       pop   temp6
       dec   temp6
       brne  next_search1
       clr   a0                   ; If not find valid track descriptor
       clr   a1                   ; in multisess.track,Try 1.st session
       clr   a2                   ; if not this in 1st session,CRASH!
       clr   a3
       ldi   temp6,0x40
       rjmp  test3
Next_search1:
       ldi   zaddrl,v_bufferA
       ldi   zaddrH,v_bufferA>>8
       ld    temp5,z+  ;desc.pointer -> 0x01 DOS/ISO9660
       ld    temp2,z+  ;                0x02 JULIET
       cpi   temp2,0x43      ;"C"       0xFF !None!
       brne  test3     ; Find  (JULIET) descriptor (IF any)
       ld    temp1,z+
       ld    temp2,z+
       ld    temp3,z+
       cpi   temp1,0x44      ;"D"
       brne  test3
       cpi   temp2,0x30      ;"0"
       brne  test3
       cpi   temp3,0x30      ;"0"
       brne  test3
       ld    temp1,z+
       ld    temp2,z+
       ld    temp3,z+
       ld    temp4,z+
       cpi   temp1,0x31      ;"1"
       brne  test3
       cpi   temp2,01
       brne  test3
       cpi   temp3,00
       brne  test3
       cpi   temp4,00
       brne  test3
       cpi   temp5,0xFF      ; temp5 <>0xFF=JOLIET
       breq  DOS             ; !Prim.Descriptor
       sbr   Flags,1<<f_joliet
       rjmp  readTOC_6

DOS:   ldi   temp1,3         ; test2 DOS/ISO9660
       sub   a0,temp1
       sbc   a1,null
       sbc   a2,null
       sbc   a3,null
DOS3:  ldi   temp1,v_BufferA
       ldi   temp2,v_BufferA>>8
       rcall CD_XferData
       ldi   zaddrl,v_bufferA
       ldi   zaddrH,v_bufferA>>8
       ld    temp5,z+              ; there's should be 0x01
       ld    temp2,z+
       cpi   temp2,0x43      ;"C"  ; ! 1st track which started with this
       brne  DOS3                  ; mark is a primary descriptor
       ld    temp1,z+              ; DOS or ISO 9960
       ld    temp2,z+
       ld    temp3,z+
       cpi   temp1,0x44      ;"D"
       brne  DOS3
       cpi   temp2,0x30      ;"0"
       brne  DOS3
       cpi   temp3,0x30      ;"0"
       brne  DOS3
       cbr   Flags,1<<f_joliet
ReadTOC_6:
       ldi   zAddrL,(v_BufferA+132) ; ISO9660 !!
       ldi   zAddrH,(v_BufferA+132)>>8
       ld    temp1,z+
       sts   v_PathSize,temp1
       ld    temp1,z+
       mov   temp2,temp1
       andi  temp2,0x7
       sts   v_PathSize+1,temp2
       ld    temp2,z+
       ld    temp3,z+
       lsr   temp3
       ror   temp2
       ror   temp1
       lsr   temp3
       ror   temp2
       ror   temp1
       lsr   temp3
       ror   temp2
       ror   temp1
       adiw  zAddrL,4
       ld    A0,z+
       ld    A1,z+
       ld    A2,z+
       ld    A3,z+
       add   temp1,A0
       adc   temp2,A1
       adc   temp3,A2
       sts   v_PathSize+2,temp1
       sts   v_PathSize+3,temp2
       sts   v_PathSize+4,temp3
       sts   v_PathPtr+2,A0
       sts   v_PathPtr+3,A1
       sts   v_PathPtr+4,A2
       sts   v_PathPtr,Null
       sts   v_PathPtr+1,Null
       ldi   temp1,v_BufferA
       ldi   temp2,v_BufferA>>8
       rcall CD_XferData
PathLoad_1:
       rcall TOC_GetPathByte
       mov   temp6,temp1
       lds   temp1,v_PathSize
       lds   temp2,v_PathPtr
       cp    temp2,temp1
       lds   temp1,v_PathSize+1
       lds   temp2,v_PathPtr+1
       cpc   temp2,temp1
       lds   temp1,v_PathSize+2
       lds   temp2,v_PathPtr+2
       cpc   temp2,temp1
       lds   temp1,v_PathSize+3
       lds   temp2,v_PathPtr+3
       cpc   temp2,temp1
       lds   temp1,v_PathSize+4
       lds   temp2,v_PathPtr+4
       cpc   temp2,temp1
       brlo  PathLoad_2
       rjmp  TableLoad_E
PathLoad_2:
       lds   temp1,v_PathPtr
       lds   temp2,v_PathPtr+1
       sub   temp1,One
       sbc   temp2,Null
       lds   temp3,v_PathPtr+2
       lds   temp4,v_PathPtr+3
       lds   temp5,v_PathPtr+4
       lsl   temp3
       rol   temp4
       rol   temp5
       rol   temp3
       rol   temp4
       rol   temp5
       rol   temp3
       rol   temp4
       rol   temp5
       or    temp3,temp2
       sts   v_PathAddr,temp1
       sts   v_PathAddr+1,temp3
       sts   v_PathAddr+2,temp4
       sts   v_PathAddr+3,temp5
       rcall TOC_GetPathByte
       rcall TOC_GetPathByte
       sts   v_DirPtr,Null
       sts   v_DirPtr+1,Null
       sts   v_DirPtr+2,temp1
       mov   A0,temp1
       rcall TOC_GetPathByte
       sts   v_DirPtr+3,temp1
       mov   A1,temp1
       rcall TOC_GetPathByte
       sts   v_DirPtr+4,temp1
       mov   A2,temp1
       mov   A3,Null
       clr   temp2
       mov   temp1,temp6
       sbrc  temp1,0
       inc   temp1
       ldi   temp3,3
       add   temp1,temp3
       adc   temp2,Null
       lds   temp3,v_PathPtr
       add   temp3,temp1
       lds   temp4,v_PathPtr+1
       adc   temp4,temp2
       sts   v_PathPtr,temp3
       sts   v_PathPtr+1,temp4
       ldi   temp1,v_BufferB
       ldi   temp2,v_BufferB>>8
       rcall CD_XferData
       sbr   StateFlags,1<<fs_DirFirst
DirLoad_1:
       rcall TOC_GetDirByte
       sbrc  StateFlags,fs_DirFirst
       rjmp  DirLoad_0
       lds   temp2,v_DirPtr+2
       lds   temp5,v_DirSize
       cp    temp2,temp5
       lds   temp3,v_DirPtr+3
       lds   temp5,v_DirSize+1
       cpc   temp3,temp5
       lds   temp4,v_DirPtr+4
       lds   temp5,v_DirSize+2
       cpc   temp4,temp5
       breq  DirLoad_20
       brlo  DirLoad_21
       rjmp  PathLoad_1
DirLoad_21:
       tst   temp1
       brne  DirLoad_0
       ldi   temp1,8
       sts   v_DirPtr,Null
       sts   v_DirPtr+1,temp1
       rjmp  DirLoad_1
DirLoad_20:
       tst   temp1          ; dir size
       brne  DirLoad_0
       rjmp  PathLoad_1
DirLoad_0:
       mov   temp6,temp1
       dec   temp6
       lds   temp1,v_DirPtr
       lds   temp2,v_DirPtr+1
       sub   temp1,One
       sbc   temp2,Null
       lds   temp3,v_DirPtr+2
       lds   temp4,v_DirPtr+3
       lds   temp5,v_DirPtr+4
       BRPL  DirLoad_10
       ldi   temp1,2047
       ldi   temp2,2047>>8
       sub   temp3,One
       sbc   temp4,Null
       sbc   temp5,Null
DirLoad_10:
       lsl   temp3
       rol   temp4
       rol   temp5
       rol   temp3
       rol   temp4
       rol   temp5
       rol   temp3
       rol   temp4
       rol   temp5
       or    temp3,temp2
       sts   v_DirAddr,temp1
       sts   v_DirAddr+1,temp3
       sts   v_DirAddr+2,temp4
       sts   v_DirAddr+3,temp5
       SBRS  StateFlags,fs_DirFirst
       rjmp  DirLoad_11
       ldi   temp3,9
       cbr   StateFlags,1<<fs_Round
       rcall TOC_SkipDirBytes
       rcall TOC_GetDirByte
       cpse  temp1,Null
       sbr   StateFlags,1<<fs_Round
       rcall TOC_GetDirByte
       mov   temp2,temp1
       andi  temp2,0x7
       breq  DirLoad_14
       sbr   StateFlags,1<<fs_Round
DirLoad_14:
       sts   v_DirSize,temp1
       rcall TOC_GetDirByte
       sts   v_DirSize+1,temp1
       rcall TOC_GetDirByte
       lds   temp2,v_DirSize+1
       lds   temp3,v_DirSize
       rcall TOC_DIV2
       rcall TOC_DIV2
       rcall TOC_DIV2
       sbrc  StateFlags,fs_Round
       rjmp  DirLoad_12
       sub   temp3,One
       sbc   temp2,Null
       sbc   temp1,Null
DirLoad_12:
       lds   temp4,v_DirPtr+2
       add   temp3,temp4
       lds   temp4,v_DirPtr+3
       adc   temp2,temp4
       lds   temp4,v_DirPtr+4
       adc   temp1,temp4
       sts   v_DirSize,temp3
       sts   v_DirSize+1,temp2
       sts   v_DirSize+2,temp1
       ldi   temp3,11
       cbr   StateFlags,1<<fs_DirFirst
       rjmp  DirLoad_13
DirLoad_11:
       ldi   temp3,24
DirLoad_13:
       rcall TOC_SkipDirBytes
       rcall TOC_GetDirByte
       sbrs  temp1,1
       rjmp  DirLoad_2
DirLoad_5:
       lds   temp1,v_DirPtr
       lds   temp2,v_DirPtr+1
       add   temp1,temp6
       adc   temp2,Null
       sts   v_DirPtr,temp1
       sts   v_DirPtr+1,temp2
       rjmp  DirLoad_1
DirLoad_2:
       ldi   temp3,6
       rcall TOC_SkipDirBytes
       rcall TOC_GetDirByte
       mov   temp5,temp1
       clr   temp4
DirLoad_3:
       tst   temp5             ; only load .mp3 files
       breq  DirLoad_5
       rcall TOC_GetDirChar
       cpi   temp1,'.'         ;     .
       brne  DirLoad_3
       tst   temp5
       breq  DirLoad_5
       rcall TOC_GetDirChar
       cpi   temp1,'m'         ;     m
       breq  DirLoad_7
       cpi   temp1,'M'         ;     M
       brne  DirLoad_3
DirLoad_7:
       tst   temp5
       breq  DirLoad_5
       rcall TOC_GetDirChar
       cpi   temp1,'p'         ;     p
       breq  DirLoad_8
       cpi   temp1,'P'         ;     P
       brne  DirLoad_3
DirLoad_8:
       tst   temp5
       breq  DirLoad_5
       rcall TOC_GetDirChar
       cpi   temp1,'3'         ;     3
       brne  DirLoad_3
DirLoad_6:
       lds   temp1,v_TrackCount
       lds   temp2,v_TrackCount+1
       add   temp1,One
       adc   temp2,Null
       sts   v_TrackCount,temp1
       sts   v_TrackCount+1,temp2
       lds   zAddrL,v_TrackPtr
       lds   zAddrH,v_TrackPtr+1
       lds   temp1,v_DirAddr
       st    z+,temp1
       lds   temp1,v_DirAddr+1
       st    z+,temp1
       lds   temp1,v_DirAddr+2
       st    z+,temp1
       lds   temp1,v_DirAddr+3
       st    z+,temp1
       lds   temp1,v_PathAddr
       st    z+,temp1
       lds   temp1,v_PathAddr+1
       st    z+,temp1
       lds   temp1,v_PathAddr+2
       st    z+,temp1
       lds   temp1,v_PathAddr+3
       st    z+,temp1
       sts   v_TrackPtr,zAddrL
       sts   v_TrackPtr+1,zAddrH
       rjmp  DirLoad_5

TableLoad_E:
       rcall cdsel
       rcall set_max_speed        ; init 4x Speed
       rcall ramsel
       lds   temp1,v_TrackCount   ; end load directory
       lds   temp2,v_TrackCount+1
       cp    temp1,Null
       cpc   temp2,Null           ; If No MP3 track$
       brne  Main_0
       sts   v_uartinbuff+1,null  ; Reset any command
wait_cd:ldi  zaddrL,mel_NO_TRACK  ; Send No track$ mel.
       ldi   zaddrH,mel_NO_TRACK>>8
       rcall SEND_MEL
       lds   temp1,v_uartinbuff+1
       cpi   temp1,15
       brne  wait_cd              ; Wait for Eject CD command
       rcall cdsel
       rcall mp3_EJECT            ; EJECT CD
       ;rjmp ini_cd

Main_0:sts   v_PlayTrackCount,temp1
       sts   v_PlayTrackCount+1,temp2
       cbr   stateflags,1<<fs_hwreset
       rcall RAMsel
       sts   v_TrackNext,Null
       sts   v_TrackNext+1,Null
       rcall TrackChange
BUFF1: rcall CD_XferBlk         ; At start
       sbrc  Flags,f_XferDone   ; full data buffer !
       rjmp  BUFF1
       rcall initbuff
       rcall cd_xferblk
       ldi   temp1,10
       rcall wait
MainLoopA:
       sbrc  Flags,f_spitransfer; wait end block transfer!
       rjmp  MainLoopA          ;
       rcall CD_XferBlk         ; load 1 sector (2kB)
       sbrc  Flags,f_XferDone   ; 1=sector loaded,test end
       rjmp  MainTxInit         ;
MainLoop_0:
       lds   temp1,v_ui_event   ; command test
       cpse  temp1,Null         ;
       rcall UIProc             ;
MainLoop_1:
       sbrs  Flags,f_demand     ; 1= STA req.DATA
       rjmp  MainLoopA          ;
       sbrs  StateFlags,fs_Play ; 1= PLAY 0=PAUSE,STOP
       rjmp  MainLoopA          ;
       rcall ReInitTx           ; send stream
       rjmp  MainLoopA          ;
MainTxInit:                     ;
       lds   temp1,v_TrackEnd   ; TEST END track
       lds   temp2,v_TrackEnd+1
       lds   temp3,v_TrackEnd+2
       cp    A0,temp1
       cpc   A1,temp2
       cpc   A2,temp3
       brlo  MainLoop_0
MainTx_1:cp  BufferDSizeL,Null  ; IF ANY data in buffer
       cpc   BufferDSizeH,Null  ; Play to end !
       breq  MainTx_2           ; endbuff -> next track
       sbrc  flags,f_spitransfer; ! wait for end block..
       rjmp  maintx_1
       sbrc  Flags,f_demand     ; STA req.data -> send
       rcall ReInitTx
       rjmp  MainTx_1
MainTx_2:rcall TrackChange      ;
       ldi   temp1,20           ; PAUSE
       rcall wait               ; 0.5 s
       rjmp  BUFF1              ; load new
;       nop
ReInitTx:cp BufferDSizeL,Null
       cpc  BufferDSizeH,Null
       breq ReInitTx_E          ; no data
       sbr  Flags,(1<<f_spitransfer)
       ld   temp1,Y+
       out  SPDR,temp1
       sub  BufferDSizeL,One
       sbc  BufferDSizeH,Null
       cpi  yAddrL,EXTBUFFEND
       brne ReInitTx_E
       cpi  yAddrH,EXTBUFFEND>>8
       brne ReInitTx_E
       ldi  yAddrH,EXTBUFFSTART>>8
       ldi  yAddrL,EXTBUFFSTART
ReInitTx_E: ret

CD_XferWSnd: mov temp1,temp3
       mov   temp2,temp4
       rcall CD_XferData
       ret

CD_XferData: sts v_OUTPOS,yAddrL
       sts   v_OUTPOS+1,yAddrH
       mov   yAddrL,temp1
       mov   yAddrH,temp2
       sbr   Flags,(1<<f_IdpTrans)
       rjmp  CD_XferIDP

CD_XferBlk:  cbr Flags,(1<<f_XferDone)      ;MAIN DATA LOOP !
       ldi   temp1,((EXTBUFFERSIZE-2048)>>8)
       ldi   temp2,(EXTBUFFERSIZE-2048)
       cp    BufferDSizeL,temp2
       cpc   BufferDSizeH,temp1
       brlo  CD_XferBlk_R
       ret
CD_XferBlk_R:sbr  Flags,(1<<f_XferDone)
       sts   v_OUTPOS,yAddrL
       sts   v_OUTPOS+1,yAddrH
       lds   yAddrL,v_INPOS
       lds   yAddrH,v_INPOS+1
CD_XferIDP:
       rcall cdsel
       rcall READ10               ; read sector
       ldi   temp3,8              ; 8*256
CD_XFerLoop:
       ldi   zAddrL,(v_INTBUFF)
       ldi   zAddrH,(v_INTBUFF>>8)
       mov   WordCount,Null
CDXferLoopA:rcall RD_DATA_R
       st    Z+,temp1
       st    Z+,temp2
       subi  WordCount,2
       brne  CDXferLoopA
EndXFerA:ldi zAddrL,(v_INTBUFF)
       ldi   zAddrH,(v_INTBUFF>>8)
       rcall RAMsel
       sbrs  Flags,f_IdpTrans
       inc   BufferDSizeH
       ldi   WordCount,128
RAMXferLoopA:
       ld    temp1,Z+             ; LOW->HIGH BUFFER
       ld    temp2,Z+
       st    Y+,temp1
       st    Y+,temp2
       dec   WordCount
       brne  RAMXferLoopA
       sbrs  Flags,f_IdpTrans
       rcall checkbuffer
       rcall CDsel
       dec   temp3
       brne  CD_XferLoop
       rcall RAMsel
       sbrc  Flags,f_IdpTrans
       rjmp  CD_XferBlk_NoMp
CD_XferBlk_E:sts v_INPOS,yAddrL
       sts   v_INPOS+1,yAddrH
CD_XferBlk_NoMp:lds yAddrL,v_OUTPOS
       lds   yAddrH,v_OUTPOS+1
       cbr   Flags,(1<<f_IdpTrans)
       ret

CheckBuffer: cpi yAddrL,EXTBUFFEND
       brne  CheckBuffer_E
       cpi   yAddrH,EXTBUFFEND>>8
       brne  CheckBuffer_E
       ldi   yAddrH,EXTBUFFSTART>>8
       ldi   yAddrL,EXTBUFFSTART
CheckBuffer_E:ret

TOC_GetPathByte:
       ldi   temp3,2048>>8
       lds   temp1,v_PathPtr
       lds   temp2,v_PathPtr+1
       cp    temp1,Null
       cpc   temp2,temp3
       brlo  TOC_GetPathByte_1
       sub   temp1,Null
       sbc   temp2,temp3
       sts   v_PathPtr,temp1
       sts   v_PathPtr+1,temp2
       lds   A0,v_PathPtr+2
       lds   A1,v_PathPtr+3
       lds   A2,v_PathPtr+4
       mov   A3,Null
       add   A0,One
       adc   A1,Null
       adc   A2,Null
       sts   v_PathPtr+2,A0
       sts   v_PathPtr+3,A1
       sts   v_PathPtr+4,A2
       ldi   temp1,v_BufferA
       ldi   temp2,v_BufferA>>8
       rcall CD_XferData
       rjmp  TOC_GetPathByte

TOC_GetPathByte_1:
       ldi   zAddrL,v_BufferA
       ldi   zAddrH,v_BufferA>>8
       add   zAddrL,temp1
       adc   zAddrH,temp2
       add   temp1,One
       adc   temp2,Null
       sts   v_PathPtr,temp1
       sts   v_PathPtr+1,temp2
       ld    temp1,z+
       ret

TOC_GetDirChar:
       sbrc  Flags,f_joliet
       rcall TOC_GetDirByte
       rcall TOC_GetDirByte
       dec   temp5
       sbrc  Flags,f_joliet
       dec   temp5
       ret

TOC_GetDirByte:
       ldi   temp3,2048>>8
       lds   temp1,v_DirPtr
       lds   temp2,v_DirPtr+1
       cp    temp1,Null
       cpc   temp2,temp3
       brlo  TOC_GetDirByte_1
       sub   temp1,Null
       sbc   temp2,temp3
       sts   v_DirPtr,temp1
       sts   v_DirPtr+1,temp2
       lds   A0,v_DirPtr+2
       lds   A1,v_DirPtr+3
       lds   A2,v_DirPtr+4
       mov   A3,Null
       add   A0,One
       adc   A1,Null
       adc   A2,Null
       sts   v_DirPtr+2,A0
       sts   v_DirPtr+3,A1
       sts   v_DirPtr+4,A2
       ldi   temp1,v_BufferB
       ldi   temp2,v_BufferB>>8
       rcall CD_XferData
       rjmp  TOC_GetDirByte

TOC_GetDirByte_1:
       ldi   zAddrL,v_BufferB
       ldi   zAddrH,v_BufferB>>8
       add   zAddrL,temp1
       adc   zAddrH,temp2
       add   temp1,One
       adc   temp2,Null
       sts   v_DirPtr,temp1
       sts   v_DirPtr+1,temp2
       ld    temp1,z+
       dec   temp6
       ret

TOC_SkipDirBytes:
       sub   temp6,temp3
       lds   temp1,v_DirPtr
       lds   temp2,v_DirPtr+1
       add   temp1,temp3
       adc   temp2,Null
       sts   v_DirPtr,temp1
       sts   v_DirPtr+1,temp2
       ret

TOC_DIV2:lsr temp1
       ror   temp2
       ror   temp3
       ret

clbuf: ldi   xAddrL,extbuffstart       ; start RAMbuff
       ldi   xAddrH,extbuffstart>>8    ;
       ldi   yaddrL,extbuffersize      ; buff counter
       ldi   yaddrH,extbuffersize>>8
clsBUF:st    x+,Null                   ; clear RAMbuff
       sbiw  yaddrl,1
       brne  clsbuf
       ret
TrackChange:
       rcall clbuf
       rcall initbuff
       lds   temp5,v_PlayMode
       lds   temp1,v_TrackNext
       lds   temp2,v_TrackNext+1
       lds   temp3,v_PlayTrackCount
       lds   temp4,v_PlayTrackCount+1
       cp    temp1,temp3
       cpc   temp2,temp4
       brlo  TrackChange_1
       cpi   temp5,pm_repeat
       breq  TrackChange_0
       cbr   StateFlags,(1<<fs_play)
TrackChange_0:
       clr   temp1
       clr   temp2
TrackChange_1:
       sts   v_TrackNum,temp1
       sts   v_TrackNum+1,temp2
       mov   temp3,temp1
       mov   temp4,temp2
       cpi   temp5,pm_repeat1
       breq  TrackChange_9
       add   temp1,One
       adc   temp2,Null
TrackChange_9:
       sts   v_TrackNext,temp1
       sts   v_TrackNext+1,temp2
TrackChange_35:
       lsl   temp3
       rol   temp4
       rol   temp3
       rol   temp4
       rol   temp3
       rol   temp4
       ldi   zAddrL,v_TrackTable
       ldi   zAddrH,v_TrackTable>>8
       add   zAddrL,temp3
       adc   zAddrH,temp4
       ld    temp5,z+
       ld    A0,z+
       ld    A1,z+
       ld    A2,z+
       mov   temp6,A0
       andi  temp6,0x7
       clr   A3
       lsr   A2
       ror   A1
       ror   A0
       lsr   A2
       ror   A1
       ror   A0
       lsr   A2
       ror   A1
       ror   A0
       ld    temp1,z+          ; path and flags
       sts   v_Temp,temp1
       ld    temp1,z+
       sts   v_Temp+1,temp1
       ld    temp1,z+
       sts   v_Temp+2,temp1
       ld    temp1,z+
       sts   v_Temp+3,temp1
       ldi   temp3,v_BufferA
       ldi   temp4,v_BufferA>>8
       rcall CD_XferWSnd
       ldi   temp3,v_BufferB
       ldi   temp4,v_BufferB>>8
       rcall CD_XferWSnd
       ldi   zAddrL,v_BufferA
       ldi   zAddrH,v_BufferA>>8
       add   zAddrL,temp5
       adc   zAddrH,temp6     ; Dir entry is HERE
       adiw  zAddrL,2
       ld    A0,z+
       ld    A1,z+
       ld    A2,z+
       ld    A3,z+
       sts   v_TrackStart,A0
       sts   v_TrackStart+1,A1
       sts   v_TrackStart+2,A2
       sts   v_TrackStart+3,A3
       adiw  zAddrL,4
       ld    temp1,z+
       ld    temp2,z+
       ld    temp3,z+
       ld    temp4,z+
       sts   v_TrackSizeB,temp1
       sts   v_TrackSizeB+1,temp2
       sts   v_TrackSizeB+2,temp3
       sts   v_TrackSizeB+3,temp4
       clr   temp5
       tst   temp1
       breq  TrackChange_2
       inc   temp5
TrackChange_2:
       lsr   temp4
       ror   temp3
       ror   temp2
       brcc  TrackChange_3
       inc   temp5
TrackChange_3:
       lsr   temp4
       ror   temp3
       ror   temp2
       brcc  TrackChange_4
       inc   temp5
TrackChange_4:
       lsr   temp4
       ror   temp3
       ror   temp2
       brcc  TrackChange_8
       inc   temp5
TrackChange_8:
       tst   temp5
       breq  TrackChange_5
       add   temp2,One
       adc   temp3,Null
       adc   temp4,Null
TrackChange_5:
       sts   v_TrackSize,temp2
       sts   v_TrackSize+1,temp3
       sts   v_TrackSize+2,temp4
       sts   v_TrackSize+3,Null
       add   temp2,A0
       adc   temp3,A1
       adc   temp4,A2
       sts   v_TrackEnd,temp2
       sts   v_TrackEnd+1,temp3
       sts   v_TrackEnd+2,temp4
       adiw  zAddrL,18
       ldi   temp1,(v_TrackInfo+o_FileName+1)
       ldi   temp2,(v_TrackInfo+o_FileName+1)>>8
       ld    temp5,z+
       sbrc  Flags,f_joliet
       lsr   temp5
       sts   v_TrackInfo+o_FileName,temp5
       sub   temp1,zAddrL
       sbc   temp2,zAddrH
TrackChange_6:
       ld    temp3,z
       sbrs  Flags,f_joliet
       rjmp  TrackChange_20
       adiw  zAddrL,1
       ld    temp3,z
       subi  temp1,1
       sbc   temp2,Null
TrackChange_20:
       adc   zAddrL,temp1
       adc   zAddrH,temp2
       st    z+,temp3
       sub   zAddrL,temp1
       sbc   zAddrH,temp2
       dec   temp5
       brne  TrackChange_6
       lds   temp5,v_Temp
       lds   A0,v_Temp+1
       lds   A1,v_Temp+2
       lds   A2,v_Temp+3
       clr   A3
       mov   temp6,A0
       andi  temp6,0x7
       lsr   A2
       ror   A1
       ror   A0
       lsr   A2
       ror   A1
       ror   A0
       lsr   A2
       ror   A1
       ror   A0
       ldi   temp3,v_BufferA
       ldi   temp4,v_BufferA>>8
       rcall CD_XferWSnd
       ldi   temp3,v_BufferB
       ldi   temp4,v_BufferB>>8
       rcall CD_XferWSnd
       ldi   zAddrL,v_BufferA
       ldi   zAddrH,v_BufferA>>8
       add   zAddrL,temp5
       adc   zAddrH,temp6    ; Path entry is HERE
       ld    temp5,z+
       adiw  zAddrL,7
       ldi   temp1,(v_TrackInfo+o_PathName+1)
       ldi   temp2,(v_TrackInfo+o_PathName+1)>>8
       sbrc  Flags,f_joliet
       lsr   temp5
       sts   v_TrackInfo+o_PathName,temp5
       tst   temp5
       breq  TrackChange_22
       sub   temp1,zAddrL
       sbc   temp2,zAddrH
TrackChange_10:
       ld    temp3,z
       sbrs  Flags,f_joliet
       rjmp  TrackChange_21
       adiw  zAddrL,1
       ld    temp3,z
       subi  temp1,1
       sbc   temp2,Null
TrackChange_21:
       add   zAddrL,temp1
       adc   zAddrH,temp2
       st    z+,temp3
       sub   zAddrL,temp1
       sbc   zAddrH,temp2
       dec   temp5
       brne  TrackChange_10
TrackChange_22:
       lds   Temp5,v_TrackSizeB
       lds   Temp6,v_TrackSizeB+1
       lds   A0,v_TrackEnd
       lds   A1,v_TrackEnd+1
       lds   A2,v_TrackEnd+2
       sub   A0,One
       sbc   A1,Null
       sbc   A2,Null
       clr   A3
       andi  Temp6,0x7
       cpi   Temp5,128
       cpc   Temp6,Null
       brsh  TrackChange_11
       cp    Temp6,Null
       cpc   Temp5,Null
       brne  TrackChange_12
       ldi   Temp6,0x8
TrackChange_11:
       subi  Temp5,128
       sbc   Temp6,Null         ; calc offset
       ldi   temp3,v_BufferA
       ldi   temp4,v_BufferA>>8
       rcall CD_XferWSnd
       rjmp  TrackChange_13

TrackChange_12:
       sub   A0,One
       sbc   A1,Null
       sbc   A2,Null
       subi  Temp6,-0x8
       subi  Temp5,128
       sbc   Temp6,Null
       ldi   temp3,v_BufferA
       ldi   temp4,v_BufferA>>8
       rcall CD_XferWSnd
       ldi   temp3,v_BufferB
       ldi   temp4,v_BufferB>>8
       rcall CD_XferWSnd
TrackChange_13:
       ldi   zAddrL,v_BufferA
       ldi   zAddrH,v_BufferA>>8
       add   zAddrL,temp5
       adc   zAddrH,temp6
       ld    temp1,z+
       cpi   temp1,'T'
       brne  TrackChange_14
       ld    temp1,z+
       cpi   temp1,'A'
       brne  TrackChange_14
       ld    temp1,z+
       cpi   temp1,'G'
       brne  TrackChange_14
       ldi   temp5,125
       ldi   temp1,v_TrackInfo+o_Name
       ldi   temp2,(v_TrackInfo+o_Name)>>8
       sub   temp1,zAddrL
       sbc   temp2,zAddrH
TrackChange_16:
       ld    temp3,z
       add   zAddrL,temp1
       adc   zAddrH,temp2
       st    z+,temp3
       sub   zAddrL,temp1
       sbc   zAddrH,temp2
       dec   temp5
       brne  TrackChange_16
       rjmp  TrackChange_15

TrackChange_14:
       ldi   temp5,125
       ldi   zAddrL,v_TrackInfo+o_Name
       ldi   zAddrH,(v_TrackInfo+o_Name)>>8
TrackChange_17:
       st    z+,Null
       dec   temp5
       brne  TrackChange_17
TrackChange_15:
       lds   A0,v_TrackStart
       lds   A1,v_TrackStart+1
       lds   A2,v_TrackStart+2
       lds   A3,v_TrackStart+3
       lds   temp1,v_TrackInfo+o_PathName
       ldi   zAddrL,(v_TrackInfo+o_FilePath+1)
       ldi   zAddrH,(v_TrackInfo+o_FilePath+1)>>8
       ldi   temp3,(v_TrackInfo+o_PathName+1)
       ldi   temp4,(v_TrackInfo+o_PathName+1)>>8
       sub   temp3,zAddrL
       sbc   temp4,zAddrH
       clr   temp5
       tst   temp1
       breq  TrackChange_32
TrackChange_30:
       add   zAddrL,temp3
       adc   zAddrH,temp4
       ld    temp2,z
       sub   zAddrL,temp3
       sbc   zAddrH,temp4
       st    z+,temp2
       dec   temp1
       brne  TrackChange_30
TrackChange_32:
       tst   temp5
       brne  TrackChange_31
       ldi   temp2,'/'
       st    z+,temp2
       lds   temp1,v_TrackInfo+o_FileName
       ldi   temp3,(v_TrackInfo+o_FileName+1)
       ldi   temp4,(v_TrackInfo+o_FileName+1)>>8
       sub   temp3,zAddrL
       sbc   temp4,zAddrH
       ser   temp5
       rjmp  TrackChange_30

TrackChange_31:
       lds   temp1,v_TrackInfo+o_PathName
       lds   temp2,v_TrackInfo+o_FileName
       add   temp1,temp2
       inc   temp1
       sts   v_TrackInfo+o_FilePath,temp1
       rcall UI_TrackChangeProc    ; User Interface  Update
       ret

; ATA - ATAPI COMMANDS

RD_DATA_R:  ldi   temp1,datareg
            rcall CDREAD
            ret
RD_STATUS:  ldi   temp1,D_STATUS
            rcall CDREAD
            ret
RD_STATUS_A:ldi   temp1,D_STATUS_A
            rcall CDREAD
            ret
RD_ERRORR:  ldi   temp1,D_ERRORR
            rcall CDREAD
            ret
WR_COMMAND: lds   temp2,COMMAND
            ldi   temp1,D_COMMAND
            rcall CDWRITE
            ret
WR_SC:      lds   temp2,SECTOR_C
            ldi   temp1,D_SECTOR_C
            rcall CDWRITE
            ret
WR_SN:      lds   temp2,SECTOR_N
            ldi   temp1,D_SECTOR_N
            rcall CDWRITE
            ret
WR_CL:      lds   temp2,CILYNDER_L
            ldi   temp1,D_CILYNDER_L
            rcall CDWRITE
            ret
WR_CH:      lds   temp2,CILYNDER_H
            ldi   temp1,D_CILYNDER_H
            rcall CDWRITE
            ret
WR_DC:      lds   temp2,DEVICE_C
            ldi   temp1,D_DEVICE_C
            rcall CDWRITE
            ret
WR_DH:      lds   temp2,DEVICE_H
            ldi   temp1,D_DEVICE_H
            rcall CDWRITE
            ret
WR_FEATURES:lds   temp2,FEATURES
            ldi   temp1,D_FEATURES
            rcall CDWRITE
            ret

ST1:   cbr   stateflags,(1<<ERR)
       rcall RD_STATUS
       sbrc  temp1,7 ;BSY=0,DRQ=0
       rjmp  ST1
       sbrc  temp1,3
       rjmp  ST1
       sbrc  temp1,0 ;ERROR
       sbr   stateflags,(1<<ERR)
       ret

ST2:   cbr   stateflags,(1<<ERR)
       rcall RD_STATUS
       sbrc  temp1,7
       rjmp  ST2
       sbrs  temp1,3
       rjmp  ST2
       sbrc  temp1,0 ;ERROR
       sbr   stateflags,(1<<ERR)
       ret     ;BSY=0,DRQ=1

WR_C_P:rcall DEVICE_SELECT  ; ATAPI PACKET COMMAND
       rcall WR_FEATURES
       rcall WR_SC
       rcall WR_SN
       rcall WR_CH
       rcall WR_CL
       rcall WR_DH
       rcall WR_COMMAND
       rcall ST2
       ret

WR_C_P1:ldi  temp4,0x06     ; PACKET SIZE   ;!12 Byte(6*2)
       ldi   zAddrL,BP0
       ldi   zAddrH,BP0>>8
Send_PKT:ld  temp1,z+
       ld    temp2,z+
       rcall CDWriteData
       dec   temp4
       brne  Send_Pkt
       ldi   zAddrL,BP0
       ldi   zAddrH,BP0>>8
       ldi   temp1,12
Clr_Pkt:st   z+,Null
       dec   temp1
       brne  Clr_Pkt        ; erase packet RAM  on EXIT     !
       ret

DEVICE_SELECT: rcall ST1
       rcall   WR_DH
       rcall   ST1
       ret

INI_ATAPI:rcall DEVICE_SELECT
       ldi   temp1,0   ;       0B00000010;No IRQ
       sts   DEVICE_C,null    ;    temp1
       rcall WR_DC
       rcall ST1
       ret

TEST_UNIT_READY:rcall WR_C_P
       rcall WR_C_P1
       rcall RD_STATUS_A
       rcall RD_STATUS
       ret

READ10:rcall WR_C_P          ; CDROM_READCMD
       ldi   temp1,0x28
       sts   BP0,temp1
       sts   BP5,A0
       sts   BP4,A1
       sts   BP3,A2
       sts   BP2,A3
       ;sts  BP7,Null
       sts   BP8,One         ; SECTOR=2048 byte
       add   A0,One
       adc   A1,Null
       adc   A2,Null
       adc   A3,Null
       rcall WR_C_P1
       rcall ST2
       ret

PLAY_AUDIO_MSF:rcall  WR_C_P
       ldi   temp1,0x47
       sts   BP0,temp1
       rcall WR_C_P1
       rcall RD_STATUS_A
       rcall ST1
       ret

READ_TOC:rcall WR_C_P
       ldi   temp1,0x43
       sts   BP0,temp1           ; Bit 2
       ;ldi  temp1,0x02          ; 0=LBA,1=MSF
       ;sts  BP1,temp1
       ldi   temp1,12
       sts   BP8,temp1           ; return 12 byte$
       rcall WR_C_P1
       rcall RD_STATUS_A
       rcall ST2
       ret

ST_UNIT:rcall WR_C_P
       ldi   temp1,0x1B
       sts   BP0,temp1        ; Code
       ;sts  BP4,flag_cd      ; 00 = Stop  the disc  !NOT equ STOP PLAY/SCAN !!!
       rcall WR_C_P1          ; 01 = Start the disc  & read TOC
       rcall RD_STATUS_A      ; 10 = Eject the disc  if possible
       rcall ST1              ; 11 = Load  the disc  & close tray
       ret

PAUSE_RESUME:rcall WR_C_P
       rcall ST2
       ldi   temp1,0x4B
       sts   BP0,temp1
      ;ldi   temp1,0x01       ; 0=pause   (command)
      ;sts   BP8,temp1        ; 1=unpause
       rcall WR_C_P1
       rcall RD_STATUS_A
       rcall ST1
       ret

READ_SUB:                     ; CD/DA Only     !!!
       rcall WR_C_P           ; Read Sub_channel!
       ldi   temp1,0x42
       sts   BP0,temp1
       ldi   temp1,0x02       ; MSF
       sts   BP1,temp1
       ldi   temp1,0x40       ; SubQ
       sts   BP2,temp1
       sts   BP3,One          ; Audio Status (Format Code 01)
       ldi   temp1,16         ; Alloc   length
       sts   BP8,temp1
       rcall WR_C_P1
       rcall RD_STATUS_A
       rcall ST2
       rcall RD_DATA_R
       sts   DA_MODE,temp2    ; Status   !! CD/DA Only
       rcall RD_DATA_R        ; return 16  byte
       rcall RD_DATA_R        ; Status Code:
       rcall RD_DATA_R        ; 0x11 = Play in progress
       sts   v_TRACKNUM,temp1 ;
       rcall RD_DATA_R        ; 0x12 = Play paused
       rcall RD_DATA_R        ; 0x13 = Play completed success.
       rcall RD_DATA_R        ; 0x14 = Play stopped   due  error
       sts   POS_M,temp2      ;   DA   track time pos. (for UI)
       rcall RD_DATA_R        ; 0x15 = No  current status
       sts   POS_S,temp1
       ret                    ; 0x00 = Byte status not valid

SET_MAX_SPEED:
       rcall cdsel
       rcall WR_C_P           ; x4  -   FUNGUJE!
       ldi   temp1,0xBB
       sts   BP0,temp1
       ldi   temp1,194
       sts   BP3,temp1
       ldi   temp1,2
       sts   BP2,temp1
       rcall WR_C_P1
       rcall RD_STATUS_A
       rcall RD_STATUS
       rcall ramsel
       ret

STOP_PLAY:
      rcall WR_C_P
      rcall ST2
      ldi   temp1,0x4E
      sts   BP0,temp1
      rcall WR_C_P1
      ret

CDWrite:out DDRA,FF      ; 8 bit command
       out  PORTA,temp1
       sbi  PORTB,CntrlLatch
       cbi  PORTB,CntrlLatch
       out  PORTA,temp2
       nop
       cbi  PORTD,WR
       nop
       sbi  PORTD,WR
       out  PORTA,Null
       out  DDRA,Null
       ret

CDWriteData:ldi  temp3,DataReg ; 16 bit Packet data
       out  DDRC,FF
       out  DDRA,FF
       out  PORTA,temp3
       sbi  PORTB,CntrlLatch
       cbi  PORTB,CntrlLatch
       out  PORTA,temp1
       out  PORTC,temp2
       nop
       cbi  PORTD,WR
       nop
       sbi  PORTD,WR          ; strobe   DATA
       out  PORTA,NULL
       out  PORTC,NULL
       out  DDRA,NULL
       out  DDRC,NULL
       ret

CDRead:out  DDRA,FF           ; 16 bit CD data
       out  PORTA,temp1       ; or low 8 bit$ CD status
       sbi  PORTB,CntrlLatch
       cbi  PORTB,CntrlLatch
       out  DDRA,Null
       out  DDRC,Null
       out  PORTA,Null
       out  PORTC,Null
       cbi  PORTD,RD          ; strobe   DATA
       nop
       in   temp1,PINA        ; LOW  byte
       in   temp2,PINC        ; HIGH byte
       sbi  PORTD,RD
       ret

EXT_EE_RD:ldi i2cadr, C_EXTEEaddR+i2cwr
EXT_EE_RD_1: rcall i2c_start
       brcs  EXT_EE_RD_1
       mov   i2cdata,temp2
       rcall i2c_write
       mov   i2cdata,temp1
       rcall i2c_write
       rcall i2c_stop
       ldi   i2cadr, C_EXTEEaddR+i2crd
       rcall i2c_start
       lds   temp1,v_Temp
EXT_EE_RD_2: clc
       rcall i2c_read
       st    z+,i2cdata
       dec   temp1
       brne  EXT_EE_RD_2
       sec
       rcall i2c_read
       rcall i2c_stop
       ret

LoadEEText:
       ldi   zAddrL,v_ui_staticStrs8
       ldi   zAddrH,v_ui_staticStrs8>>8
       ldi   temp1,ui_strEEaddr
       ldi   temp2,ui_strEEaddr>>8
       ldi   temp3,240
       sts   v_Temp,temp3
       rcall EXT_EE_RD
       ldi   zAddrL,(v_ui_staticStrs8+240)  ;
       ldi   zAddrH,(v_ui_staticStrs8+240)>>8
       ldi   temp1,(ui_strEEaddr+240)
       ldi   temp2,(ui_strEEaddr+240)>>8
       ldi   temp3,240
       sts   v_Temp,temp3
       rjmp  EXT_EE_RD

;    description in comddesc.asm
;    user Interface prog for the 2 x 16 Lcd version
;    all extrs serial commands are removd here
;    In this version the AT90S8515 is the UI master

.EQU   ui_mode_run             = 1     ; ui enabled
.EQU   ui_mode_pause           = 0     ; ui disabled
.EQU   ui_mode_setupmapping    = 2     ;
.EQU   ui_cmd_reset            = 0     ; init ui
.EQU   ui_cmd_ircode           = 1     ; + 2 Byte Code
.EQU   ui_cmd_modeselect       = 2     ; + mode code
.EQU   ui_cmd_mappingreset     = 3     ;
.EQU   ui_cmd_id               = 4     ; responds with ID if running
.EQU   ui_mappingEEaddr        = 0     ; mapping is saved in the EEPROM at this addr
.EQU   ui_mappingEEsignature   = 0x93  ; signature at above pos, else there is no map
.EQU   ui_cmddescEEaddr        = 64    ; command descriptions are saved here(16 Bytes per cmd)
.EQU   ui_strEEaddr            = 576   ; strs start here(20*8+20*16)
.EQU   ui_settingsEEsignature  = 0x57  ; signature for valid user settings
.EQU   ui_settingsEEaddr       = 1200  ; settings (vol,bass, ...) are saved here
.EQU   ui_display_time         = 0     ;
.EQU   ui_display_title        = 1
.EQU   ui_display_artist       = 2
.EQU   ui_display_album        = 3
.EQU   ui_display_comment      = 4
.EQU   ui_display_file         = 5
.EQU   ui_display_info1        = 6
.EQU   ui_display_info2        = 7
.EQU   ui_display_trackselect  = 8
.EQU   ui_display_Volume       = 9
.EQU   ui_display_Bass         = 10
.EQU   ui_display_Treble       = 11
.EQU   ui_display_Pitch        = 12
.EQU   ui_display_PlayMode     = 13
.EQU   ui_display_ListSelect   = 14
.EQU   ui_display_LightMode    = 15
.EQU   ui_display_No_CD        = 16
.EQU   ui_level_normal         = 0
.EQU   ui_level_1              = 0
.EQU   ui_level_2              = 1
.EQU   ui_str8_track           = 18
.EQU   ui_str8_Code            = 19
.EQU   ui_time_trackselect     = 10
.EQU   ui_time_volume          = 10
.EQU   ui_time_bass            = 10
.EQU   ui_time_treble          = 10
.EQU   ui_time_light           = 20
.EQU   ui_state_alwayslight    = 0
.EQU   ui_state_neverlight     = 1
.EQU   ui_state_lightondem     = 2
.EQU   ui_str16_modenormal     = 0
.EQU   ui_lastcmd              = 26    ;Max command No
.EQU   LASTCMD                 = 5
.EQU   b_IR_first              = 4
.EQU   b_IR_last               = 5
.EQU   ui_seekstep             = 32
.EQU   ui_trackstep            = 10
.EQU   VolMAX                  = 121
.EQU   C_TrebleMax             = 12
.EQU   C_TrebleMin             = -12
.EQU   C_BassMax               = 12
.EQU   C_BassMin               = -12
.EQU   C_PlayModeMax           = 2
.EQU   C_PlayModeMin           = 0

UI_Init:ldi  temp1,ui_mode_setupmapping    ; ui_mode_run
       sts   v_ui_mode,temp1
       ldi   temp1,'-'                     ; timemode "-"
       sts   v_ui_timemode,temp1
       out   TCCR1A,Null
       ldi   temp1,5
       out   TCCR1B,temp1
       ldi   temp1,HIGH(ui_timerval)
       out   TCNT1H,temp1
       ldi   temp1,LOW(ui_timerval)
       out   TCNT1L,temp1
       ldi   temp1,0x80
       out   TIMSK,temp1
       rcall LoadMappingEE
       ret

UIProc:lds   temp1,v_ui_event   ; last command byte
       sbrc  temp1,f_ui_timer   ;
       rcall DisplayUpdate
       lds   temp1,v_ui_event
       sbrs  temp1,f_ui_uart    ; ! valid command ?
       rjmp  UIProc_E
       cbr   temp1,1<<f_ui_uart ; clear command flag
       sts   v_ui_event,temp1   ;
       sbrc  Flags,f_CmdWaiting ; wait command ?
       rjmp  UIProc_1           ;
       lds   temp1,v_UARTInBuff
       rjmp  uiproc_2           ; 1.st byte=flag for wait
ui_proc3:sts v_UARTInCount,Null
       rjmp  UIProc_E
UIProc_2:
       sbr   Flags,(1<<f_CmdWaiting)
       rjmp  uiproc_e

uiproc_1:lds temp1,v_uartinbuff+1
       cpi   temp1,0x20           ; Max command num.
       brsh  ui_proc3
       cpi   temp1,0x00           ; IGNORE EMPTY COMMAND
       breq  ui_proc3
       dec   temp1
       sts   v_ui_mappingcount,temp1 ;command String
       lds   temp2,v_ui_mode
       cpi   temp2,2            ; string mode
       brne  uiproc5
       push  temp1
       cpi   temp1,15           ; string  mode sel.
       brne  uiproc6
       sts   v_ui_mappingcount,null
uiproc6:rcall loadmappingeestr
       sts  v_ui_mode,one  ; !!
       pop   temp1
uiproc5:ldi  zaddrl,ircmdtab
       ldi   zaddrh,ircmdtab>>8
       add   zAddrL,temp1       ; command!!
       adc   zAddrH,Null
       sts   DA_COMMAND,Null    ; Clear CDDA Command
       IJMP

UIProc_E: ret


LoadMappingEEStr:
       ldi   zAddrL,v_ui_mappinginfo     ;POSLAT Z EEPROM DO RAM
       ldi   zAddrH,v_ui_mappinginfo>>8
       lds   temp1,v_ui_mappingcount
       clr   temp2
       lsl   temp1
       lsl   temp1
       rol   temp1
       rol   temp2
       rol   temp1
       rol   temp2
       ldi   temp5,ui_cmddescEEaddr ; prikazy 1
       add   temp1,temp5
       ldi   temp5,ui_cmddescEEaddr>>8
       adc   temp2,temp5
       ldi   temp3,16
       sts   v_Temp,temp3
       rcall EXT_EE_RD
       ret

LoadMappingEE:sts  v_Temp,One
       ldi   zAddrL,v_Temp+1
       ldi   zAddrH,(v_Temp+1)>>8
       ldi   temp1,ui_mappingEEaddr
       ldi   temp2,ui_mappingEEaddr>>8
       rcall EXT_EE_RD
       lds   temp1,v_Temp+1
       cpi   temp1,ui_mappingEEsignature
       breq  LoadMappingEE_1
       ldi   temp1,ui_mode_setupmapping
       sts   v_ui_mode,temp1
       sts   v_ui_mappingcount,Null
       rcall LoadMappingEEStr
       ret

LoadMappingEE_1:ldi temp1,ui_lastcmd*2
       sts   v_Temp,temp1
       ldi   zAddrL,v_ui_irmap
       ldi   zAddrH,(v_ui_irmap)>>8
       LDI   temp1,ui_mappingEEaddr+1
       LDI   temp2,(ui_mappingEEaddr+1)>>8
       RCALL EXT_EE_RD
       RET

ICMD_EJECT:
      ldi temp1,0x06
      sts   DA_COMMAND,temp1
MP3_EJECT:sbrs  StateFlags,fs_eject
      rjmp   DA_LOAD
      cbr    StateFlags,(1<<fs_eject)
      pop    temp1                ; SP-2!(BREAK FROM SUB)
      pop    temp1
      rcall  cdsel
      rcall  ST_UNIT              ; stop the disc
      ldi    temp1,20
      nop
      rcall  WAIT
      ldi    temp1,0b00000010     ; eject disc
      sts    BP4,temp1
      rcall  ST_UNIT
      sts    v_uartinbuff+1,null
      ldi    zaddrl,mel_cd_eject
      ldi    zaddrH,mel_cd_eject>>8
      rcall  send_mel
wload:ldi    temp1,5
      rcall  wait
      lds    temp1,v_uartinbuff+1 ; wait EJECT\LOAD command
      cpi    temp1,15
      brne   wload
      ldi    zaddrl,mel_cd_load
      ldi    zaddrH,mel_cd_load>>8
      rcall  send_mel
      ldi    temp1,20
      rcall  wait
      sts    v_uartinbuff+1,null  ; clear UI command
      rjmp   DA_LOAD              ; load new CD

ICMD_PLAY:sts DA_COMMAND,One
      lds    temp1,DA_COMMAND+1
      cp     temp1,One
      breq   A_PAUSE1
      sts    DA_COMMAND+1,One     ; PAUSE
      cbr    StateFlags,(1<<fs_Play)
      rjmp   CMD_NONE
A_PAUSE1:sts DA_COMMAND+1,null    ; UNPAUSE
       sbr   Stateflags,(1<<fs_Play)
       rjmp  CMD_NONE

ICMD_STOP:ldi temp1,0x03
       sts   DA_COMMAND,temp1
       sts   v_TrackNext,Null
       sts   v_TrackNext+1,Null
       rcall TrCH
       rjmp  stop2

ICMD_PAUSE:  ldi temp1,0x02
       sts   DA_command,temp1
stop2: cbr   StateFlags,(1<<fs_Play)
       rjmp  CMD_NONE

ICMD_FWD:ldi temp1,ui_seekstep
       add   A0,temp1
       adc   A1,Null
       adc   A2,Null
       adc   A3,Null
       lds   temp2,v_Trackend
       lds   temp3,v_TrackEnd+1
       lds   temp4,v_TrackEnd+2
       cp    A0,temp2
       cpc   A1,temp3
       cpc   A2,temp4
       brlo  ICMD_FWD_2
       rcall TrCh
ICMD_FWD_2:rjmp CMD_NONE

ICMD_BWD:ldi temp1,ui_seekstep
       sub   A0,temp1
       sbc   A1,Null
       sbc   A2,Null
       sbc   A3,Null
       lds   temp2,v_TrackStart
       lds   temp3,v_TrackStart+1
       lds   temp4,v_TrackStart+2
       cp    A0,temp2
       cpc   A1,temp3
       cpc   A2,temp4
       brsh  ICMD_BWD_2
       rjmp  ICMD_TRACK_BWD
ICMD_BWD_2:rjmp CMD_NONE

ICMD_SKIP50F:ldi temp1,50
       sts v_ui_skipcount,temp1
       rjmp  ICMD_TRACK_FWD

ICMD_SKIP10F:ldi temp1,10
       sts v_ui_skipcount,temp1   ; FORWARD
ICMD_TRACK_FWD:
       ldi   temp1,0x05
       sts   DA_COMMAND,temp1
       lds   temp1,v_ui_skipcount
       lds   temp2,v_TrackNum
       lds   temp3,v_TrackNum+1
       add   temp2,temp1
       adc   temp3,Null
       lds   temp4,v_playtrackcount
       lds   temp5,v_playtrackcount+1
       inc   temp2 ; !
       cp    temp2,temp4
       cpc   temp3,temp5
       brsh  fwd_a
       dec   temp2 ; !
       sts   v_TrackNext,temp2
       sts   v_TrackNext+1,temp3
       rjmp  fwd_b
FWD_A: sts   v_tracknext,null
       sts   v_tracknext+1,null
FWD_B: rcall TrCH
       sts   v_ui_skipcount,One
       rjmp  CMD_NONE

ICMD_REPEAT:ldi temp1,0x08        ; Repeat track
       sts   DA_command,temp1
       sts   v_ui_skipcount,null
       rjmp  REPTR

ICMD_SKIP50B:ldi temp1,50
       sts   v_ui_skipcount,temp1
       rjmp  ICMD_TRACK_BWD
ICMD_SKIP10B:ldi temp1,10
       sts   v_ui_skipcount,temp1 ; BACKWARD
ICMD_TRACK_BWD:
       ldi   temp1,0x04
       sts   DA_COMMAND,temp1
REPTR: lds   temp1,v_ui_skipcount
       lds   temp2,v_TrackNum
       lds   temp3,v_TrackNum+1
       sub   temp2,temp1
       sbc   temp3,Null
       brpl  ICMD_BWDT_1
       lds   temp2,v_PlayTrackCount
       subi  temp2,2
       lds   temp3,v_PlayTrackCount+1
ICMD_BWDT_1: sts  v_TrackNext,temp2
       sts   v_TrackNext+1,temp3
       sts   v_ui_skipcount,One
BWD_A: rcall TrCh
       rjmp  CMD_NONE

ICMD_VOL_UP: ldi temp1,ui_time_volume
       sts   v_ui_displaytime+1,temp1
       lds   temp1,v_ui_displaymode
       cpi   temp1,ui_display_bass
       brne  ICMD_VUP_1
       rjmp  CMD_BASS_UP
ICMD_VUP_1:cpi  temp1,ui_display_treble
       brne  ICMD_VUP_2
       rjmp  CMD_TREBLE_UP
ICMD_VUP_2:cpi  temp1,ui_display_playmode
       brne  ICMD_VUP_3
       rjmp  CMD_MODE_UP
ICMD_VUP_3:cpi  temp1,ui_display_pitch
       brne  ICMD_VUP_5
       lds   temp1,v_PitchIndex
       inc   temp1
       cpi   temp1,101
       brge  ICMD_VOL_UP_E
       sts   v_PitchIndex,temp1
       rjmp  ICMD_VOL_UP_E
ICMD_VUP_5:cpi  temp1,ui_display_lightmode
       brne  ICMD_VUP_6
       lds   temp1,v_ui_state
       mov   temp2,temp1
       andi  temp1,3
       cpi   temp1,2
       brsh  ICMD_VOL_UP_E
       inc   temp1
       andi  temp2,0xFC
       or    temp1,temp2
       sts   v_ui_state,temp1
       rjmp  ICMD_VOL_UP_E
ICMD_VUP_6:cpi  temp1,ui_display_ListSelect
       brne  ICMD_VUP_7
       rjmp  ICMD_VOL_UP_E
ICMD_VUP_7:cpi  temp1,ui_display_volume
       breq  ICMD_VUP_4
       sts   v_ui_displaymode_old+1,temp1
       ldi   temp1,ui_display_volume
       sts   v_ui_displaymode,temp1
       lds   temp1,v_ui_displaylevel
       sbr   temp1,1<<ui_level_2
       sts   v_ui_displaylevel,temp1
ICMD_VUP_4:lds  temp1,v_VolumeIndex
       tst   temp1
       breq  ICMD_VOL_UP_E
       dec   temp1
       sts   v_VolumeIndex,temp1
       rcall VolSet
ICMD_VOL_UP_E:rjmp CMD_NONE

ICMD_VOL_DOWN:ldi  temp1,ui_time_volume
       sts   v_ui_displaytime+1,temp1
       lds   temp1,v_ui_displaymode
       cpi   temp1,ui_display_bass
       brne  ICMD_VDN_1
       rjmp  CMD_BASS_DOWN
ICMD_VDN_1:cpi  temp1,ui_display_treble
       brne  ICMD_VDN_2
       rjmp  CMD_TREBLE_DOWN
ICMD_VDN_2:cpi  temp1,ui_display_playmode
       brne  ICMD_VDN_3
       rjmp  CMD_MODE_DOWN
ICMD_VDN_3:cpi  temp1,ui_display_pitch
       brne  ICMD_VDN_5
       lds   temp1,v_PitchIndex
       dec   temp1
       cpi   temp1,-100
       brlt  ICMD_VOL_DOWN_E
       sts   v_PitchIndex,temp1
       rjmp  ICMD_VOL_DOWN_E
ICMD_VDN_5:cpi  temp1,ui_display_lightmode
       brne  ICMD_VDN_6
       lds   temp1,v_ui_state
       mov   temp2,temp1
       andi  temp1,3
       tst   temp1
       breq  ICMD_VOL_UP_E
       dec   temp1
       andi  temp2,0xFC
       or    temp1,temp2
       sts   v_ui_state,temp1
       rjmp  ICMD_VOL_DOWN_E
ICMD_VDN_6:cpi  temp1,ui_display_ListSelect
       brne  ICMD_VDN_7
       rjmp  ICMD_VOL_DOWN_E
ICMD_VDN_7:cpi  temp1,ui_display_volume
       breq  ICMD_VDN_4
       sts   v_ui_displaymode_old+1,temp1
       ldi   temp1,ui_display_volume
       sts   v_ui_displaymode,temp1
       lds   temp1,v_ui_displaylevel
       sbr   temp1,1<<ui_level_2
       sts   v_ui_displaylevel,temp1
ICMD_VDN_4:lds  temp1,v_VolumeIndex
       inc   temp1
       cpi   temp1,VolMax
       brsh  ICMD_VOL_DOWN_E
       sts   v_VolumeIndex,temp1
       rcall VolSet
ICMD_VOL_DOWN_E:rjmp CMD_NONE

CMD_BASS_DOWN:lds  temp1,v_BassIndex
       dec   temp1
       cpi   temp1,C_BassMin
       brlt  CMD_BTUD_E
       sts   v_BassIndex,temp1
       rcall BassSet
CMD_BTUD_E:rjmp CMD_NONE

CMD_TREBLE_DOWN:lds temp1,v_TrebleIndex
       dec   temp1
       cpi   temp1,C_TrebleMin
       brlt  CMD_BTUD_E
       sts   v_TrebleIndex,temp1
       rcall TrebleSet
       rjmp  CMD_BTUD_E

CMD_BASS_UP:lds  temp1,v_BassIndex
       inc   temp1
       cpi   temp1,C_BassMax+1
       brge  CMD_BTUD_E
       sts   v_BassIndex,temp1
       rcall BassSet
       rjmp  CMD_BTUD_E

CMD_TREBLE_UP:lds  temp1,v_TrebleIndex
       inc   temp1
       cpi   temp1,C_TrebleMax+1
       brge  CMD_BTUD_E
       sts   v_TrebleIndex,temp1
       rcall TrebleSet
       rjmp  CMD_BTUD_E

CMD_MODE_UP:lds  temp1,v_PlayMode
       inc   temp1
       cpi   temp1,C_PlayModeMax+1
       brge  CMD_BTUD_E
       sts   v_PlayMode,temp1
       rcall PlayModeChange
       rjmp  CMD_BTUD_E

CMD_MODE_DOWN: lds  temp1,v_PlayMode
       dec   temp1
       cpi   temp1,C_PlayModeMin
       brlt  CMD_BTUD_E
       sts   v_PlayMode,temp1
       rcall PlayModeChange
       rjmp  CMD_BTUD_E

PlayModeChange:lds  temp2,v_TrackNum
       lds   temp3,v_TrackNum+1
       cpi   temp1,pm_repeat1
       breq  PlayModeChange_1
       add   temp2,One
       adc   temp3,Null
PlayModeChange_1:
       sts   v_TrackNext,temp2
       sts   v_TrackNext+1,temp3
       ret

ICMD_DISPLAY:lds  temp1,v_ui_displaymode
       cpi   temp1,ui_display_info2+1
       brsh  ICMD_DISPLAY_E
       inc   temp1
       cpi   temp1,ui_display_info2+1
       brlo  ICMD_DISPLAY_E
       ldi   temp1,ui_display_time
ICMD_DISPLAY_E:sts  v_ui_displaymode,temp1
       rjmp  CMD_NONE

ICMD_SETUP:  lds  temp2,v_ui_displaymode
       cpi   temp2,ui_display_Bass
       brsh  ICMD_SETUP_1
       lds   temp1,v_ui_displaylevel
       sbrc  temp1,ui_level_2
       rjmp  ICMD_SETUP_0
       sbr   temp1,1<<ui_level_2
       sts   v_ui_displaylevel,temp1
       sts   v_ui_displaymode_old+1,temp2
ICMD_SETUP_0:ldi  temp2,ui_display_bass-1
ICMD_SETUP_1:inc  temp2
       cpi   temp2,ui_display_lightmode+1
       brsh  ICMD_SETUP_2
       sts   v_ui_displaymode,temp2
       ldi   zAddrL,DISPLAYTIMES<<1
       ldi   zAddrH,DISPLAYTIMES>>7
       subi  temp2,ui_display_Bass
       add   zAddrL,temp2
       adc   zAddrH,Null
       lpm
       sts   v_ui_displaytime+1,pmReg
ICMD_SETUP_E:rjmp CMD_NONE
ICMD_SETUP_2:sts  v_ui_displaytime+1,Null
       rjmp  CMD_NONE

ICMD_ENTER: lds  temp1,v_ui_displaymode
       cpi   temp1,ui_display_time
       brne  ICMD_ENTER_1
       lds   temp1,v_ui_timemode
       cpi   temp1,' '
       breq  ICMD_ENTER_0
       ldi   temp1,2*' '-'-'
ICMD_ENTER_0:subi temp1,' '-'-'
       sts   v_ui_timemode,temp1
       rjmp  ICMD_ENTER_E
ICMD_ENTER_1:cpi  temp1,ui_display_trackselect
       brne  ICMD_ENTER_E
       clr   temp3
ICMD_ENTER_2:lds  temp1,v_ui_displaymode_old
       sts   v_ui_displaylevel,Null
       sts   v_ui_displaytime,Null
       sts   v_ui_displaymode,temp1
       lds   temp1,v_ui_tracksel
       lds   temp2,v_ui_tracksel+1
       sts   v_ui_tracksel,Null
       sts   v_ui_tracksel+1,Null
       cpse  temp3,Null
       rjmp  ICMD_ENTER_E
       sts   v_tracknext,temp1
       sts   v_tracknext+1,temp2
       rcall TrCH
ICMD_ENTER_E:rjmp CMD_NONE
ICMD_CANCEL: lds  temp1,v_uartinbuff  ; skip par.
       sts   v_ui_skipcount,temp1
       lds   temp1,v_ui_displaymode
       cpi   temp1,ui_display_trackselect
       brne  ICMD_CANCEL_E
       SER   temp3
       rjmp  ICMD_ENTER_2
ICMD_CANCEL_E: ;rjmp CMD_NONE
ICMD_MUTE:     ;rjmp CMD_NONE
ICMD_TRACKDIS:  rjmp CMD_NONE

ICMD_SNAP:
      lds   temp1,v_ui_mode
      cpi   temp1,2              ; Toggle displaymode
      brne  snap2
      sts   v_ui_mode,one
      rjmp  cmd_none
snap2:ldi   temp1,2
      sts   v_ui_mode,temp1
      rjmp  cmd_none

ICMD_0:
ICMD_1:
ICMD_2:
ICMD_3:
ICMD_4:
ICMD_5:
ICMD_6:
ICMD_7:
ICMD_8:
ICMD_9:ldi  temp1,(IRCMDTAB+15)
       ldi  temp2,(IRCMDTAB+15)>>8
       sub  zAddrL,temp1
       sbc  zAddrH,temp2
       rjmp ICMD_NUMBER

ICMD_NUMBER: lds  temp1,v_ui_ircmd+1 ; !
       sbrs  temp1,b_ir_last
       rjmp  CMD_NONE
       ldi   temp1,ui_time_trackselect
       sts   v_ui_displaytime,temp1
       lds   temp1,v_ui_displaymode
       cpi   temp1,ui_display_trackselect
       brne  ICMD_NUMBER_1
       lds   temp1,v_ui_tracksel
       lds   temp2,v_ui_tracksel+1
       rcall mpy10
       add   temp5,zAddrL
       adc   temp6,Null
       lds   temp1,v_PlayTrackCount
       lds   temp2,v_PlayTrackCount+1
       cp    temp5,temp1
       cpc   temp6,temp2
       brlo  ICMD_NUMBER_0
ICMD_NUMBER_3:mov  temp5,zAddrL
       clr   temp6
       cp    temp5,temp1
       cpc   temp6,temp2
       brlo  ICMD_NUMBER_0
       clr   temp5
ICMD_NUMBER_0:sts  v_ui_tracksel,temp5
       sts   v_ui_tracksel+1,temp6
       rjmp  ICMD_NUMBER_E
ICMD_NUMBER_1:lds  temp2,v_ui_displaylevel
       sbrc  temp2,ui_level_2
       lds   temp1,v_ui_displaymode_old+1
ICMD_NUMBER_4:sts  v_ui_displaymode_old,temp1
       ldi   temp1,1<<ui_level_1
       sts   v_ui_displaylevel,temp1
       ldi   temp1,ui_display_trackselect
       sts   v_ui_displaymode,temp1
       lds   temp1,v_PlayTrackCount
       lds   temp2,v_PlayTrackCount+1
       rjmp  ICMD_NUMBER_3
ICMD_NUMBER_E:
ICMD_POWER:
ICMD_NONE:rjmp CMD_NONE

DisplayUpdate:sbrc Flags,f_txRunning
       ret
       rcall TimedModeCheck
       lds   temp1,v_ui_event
       cbr   temp1,1<<f_ui_timer
       sts   v_ui_event,temp1
       ldi   zAddrL,v_UARTOutBuff
       ldi   zAddrH,v_UARTOutBuff>>8
       sts   v_UARTAddr,zAddrL
       sts   v_UARTAddr+1,zAddrH
       lds   temp3,v_ui_mode
       cpi   temp3,ui_mode_setupmapping
       brne  DisplayUpdate_1
       ldi   temp1,v_ui_mappinginfo
       ldi   temp2,v_ui_mappinginfo>>8
       ldi   temp3,16
       rcall StrCopy
       ldi   temp5,ui_str8_code
       rcall Static8Copy
       lds   dd24uL,v_ui_ircmd
       lds   dd24uM,v_ui_ircmd+1
       clr   dd24uH
       rcall WR3DIGITZ
       ldi   temp1,' '
       st    z+,temp1
       st    z+,temp1
       lds   dd24uL,v_ui_ircmdold
       lds   dd24uM,v_ui_ircmdold+1
       clr   dd24uH
       rcall WR3DIGITZ
       rjmp  DisplayUpdate_E

DisplayUpdate_1:rcall TrackStrCopy
       lds   temp5,v_ui_displaymode
       rcall Static8Copy
       sts   v_ui_zSave,zAddrL
       sts   v_ui_zSave+1,zAddrH
       ldi   zAddrL,DISPCMDTAB
       ldi   zAddrH,DISPCMDTAB>>8
       add   zAddrL,temp5
       adc   zAddrH,NULL
       ICALL
DisplayUpdate_E:ldi temp1,32
       sts   v_UARTCount,temp1
       lds   temp1,v_ui_state
       sbr   Flags,1<<f_txRunning
       sbi   UCR,TXB8
       out   UDR,temp1
       ret

TimedModeCheck:
       lds   temp2,v_ui_state
       mov   temp3,temp2
       andi  temp3,3
       cpi   temp3,ui_state_alwayslight
       breq  TimeModeCheck_LA
       cpi   temp3,ui_state_neverlight
       breq  TimeModeCheck_LN
       lds   temp1,v_ui_lighttime
       tst   temp1
       breq  TimeModeCheck_LN
       dec   temp1
       sts   v_ui_lighttime,temp1
TimeModeCheck_LA:
       ori   temp2,4
       rjmp  TimeModeCheck_LE
TimeModeCheck_LN:
       cbr   temp2,4
TimeModeCheck_LE:
       sts   v_ui_state,temp2
       lds   temp1,v_ui_displaylevel
       cpi   temp1,ui_level_normal
       breq  TimedModeCheck_E
       sbrs  temp1,ui_level_2
       rjmp  TimedModeCheck_1
       lds   temp1,v_ui_displaytime+1
       tst   temp1
       breq  TimedModeCheck_0
       dec   temp1
       sts   v_ui_displaytime+1,temp1
       rjmp  TimedModeCheck_E
TimedModeCheck_0:
       lds   temp1,v_ui_displaymode_old+1
       sts   v_ui_displaymode,temp1
       lds   temp1,v_ui_displaylevel
       cbr   temp1,1<<ui_level_2
       sts   v_ui_displaylevel,temp1
TimedModeCheck_1:
       sbrs  temp1,ui_level_1
       rjmp  TimedModeCheck_E
       lds   temp1,v_ui_displaytime
       tst   temp1
       breq  TimedModeCheck_2
       dec   temp1
       sts   v_ui_displaytime,temp1
       rjmp  TimedModeCheck_E
TimedModeCheck_2:
       lds   temp1,v_ui_displaymode_old
       lds   temp2,v_ui_displaymode
       cpi   temp2,ui_display_trackselect
       brne  TimedModeCheck_3
       rjmp  ICMD_ENTER
TimedModeCheck_3:
       sts   v_ui_displaymode,temp1
       ldi   temp1,ui_level_normal
       sts   v_ui_displaylevel,temp1
TimedModeCheck_E:ret

VolSet:rcall i2c_init
       ldi   i2cadr,0x86+i2cwr
       rcall i2c_start
       ldi   i2cdata,0x46
       rcall i2c_do_transfer
       mov   i2cdata,temp1
       rcall i2c_do_transfer
       ldi   i2cdata,0xFF
       rcall i2c_do_transfer
       mov   i2cdata,temp1
       rcall i2c_do_transfer
       rcall i2c_stop
       ret

PrefacSet:lds temp1,v_BassIndex
       lds   temp4,v_TrebleIndex
       cp    temp1,temp4
       brge  PrefacSet_1
       mov   temp1,temp4
PrefacSet_1: cp temp1,Null
       brge  PrefacSet_2
       clr   temp1
PrefacSet_2: rcall   i2c_init
       ldi   i2cadr,0x86+i2cwr
       rcall i2c_start
       ldi   i2cdata,0x7D
       rcall i2c_do_transfer
       mov   i2cdata,temp1
       rcall i2c_do_transfer
       rcall i2c_stop
       ret

BassSet:mov  temp5,temp1
       subi  temp5,-15
       cpi   temp5,31
       brlo  BassSet_OK
       lds   temp1,v_BassIndex
       mov   temp5,temp1
       subi  temp5,-15
       cpi   temp5,31
       brlo  BassSet_OK
       clr   temp1
BassSet_OK:sts  v_BassIndex,temp1
       rcall PrefacSet
       lds   temp1,v_BassIndex
       rcall i2c_init
       ldi   i2cadr,0x86+i2cwr
       rcall i2c_start
       ldi   i2cdata,0x7C
       rcall i2c_do_transfer
       mov   i2cdata,temp1
       rcall i2c_do_transfer
       rcall i2c_stop
       ret

TrebleSet:mov temp5,temp1
       subi  temp5,-15
       cpi   temp5,31
       brlo  TrebleSet_OK
       lds   temp1,v_TrebleIndex
       mov   temp5,temp1
       subi  temp5,-15
       cpi   temp5,31
       brlo  TrebleSet_OK
       clr   temp1
TrebleSet_OK:sts  v_TrebleIndex,temp1
       rcall PrefacSet
       lds   temp1,v_TrebleIndex
       rcall i2c_init
       ldi   i2cadr,0x86+i2cwr
       rcall i2c_start
       ldi   i2cdata,0x7B
       rcall i2c_do_transfer
       mov   i2cdata,temp1
       rcall i2c_do_transfer
       rcall i2c_stop
       ret

TrCh:  lds   temp1,v_TrackEnd
       lds   temp2,v_TrackEnd+1
       lds   temp3,v_TrackEnd+2
       mov   A0,temp1
       mov   A1,temp2
       mov   A2,temp3
       ret

;      input: temp1,temp2 : strofs
;      temp3, temp4       : sizeofs
;      output:[sizeofs]   : size
GetTagStrSize:
       ldi   zAddrL,v_TrackInfo
       ldi   zAddrH,v_TrackInfo>>8
       add   zAddrL,temp1
       adc   zAddrH,temp2
       ldi   temp1,30
       add   zAddrL,temp1
       adc   zAddrH,Null
StrTagSize_1:
       ld    temp5,-z
       cpi   temp5,' '
       breq  StrTagSize_2
       cp    temp5,Null
       breq  StrTagSize_2
       rjmp  StrTagSize_3
StrTagSize_2:
       dec   temp1
       brne  StrTagSize_1
StrTagSize_3:
       ldi   zAddrL,v_TrackInfo
       ldi   zAddrH,v_TrackInfo>>8
       add   zAddrL,temp3
       adc   zAddrH,temp4
       st    z,temp1
       ret

UI_TrackChangeProc:
       ldi   temp6,4
       ldi   zAddrL,TrInfofstab<<1
       ldi   zAddrH,TrInfofstab>>7
UI_TrChProc_1:lpm
       adiw  zAddrL,1
       mov   temp1,pmReg
       lpm
       adiw  zAddrL,1
       mov   temp2,pmReg
       lpm
       adiw  zAddrL,1
       mov   temp3,pmReg
       lpm
       adiw  zAddrL,1
       mov   temp4,pmReg
       push  zAddrL
       push  zAddrH
       rcall GetTagStrSize
       pop   zAddrH
       pop   zAddrL
       dec   temp6
       brne  UI_TrChProc_1
       sts   v_UI_ScrollOfs,Null
       ldi   zAddrL,v_UI_TrackStr
       ldi   zAddrH,v_UI_TrackStr>>8
       ldi   temp1,' '
       st    z+,temp1
       lds   dd24uL,v_TrackNum
       lds   dd24uM,v_TrackNum+1
       clr   dd24uH
       rcall WR3DIGITZ
       lds   dd24uL,v_PlayTrackCount
       lds   dd24uM,v_PlayTrackCount+1
       clr   dd24uH
       ldi   drem24uL,'/'
       st    z+,drem24uL
       rcall WR3DIGITZ
       ret

; string tx procs:  zAddr = dest buffer
;    zAddr       = dest
;    temp1:temp2 = src
;    temp3       = count
;  --------- return ----------------
;    zAddr       = zAddr + size

StrCopy:sub  temp1,zAddrL
       sbc   temp2,zAddrH
       tst   temp3
       breq  StrCopy_E
StrCopy_1:add zAddrL,temp1
       adc   zAddrH,temp2
       ld    temp4,z
       sub   zAddrL,temp1
       sbc   zAddrH,temp2
       st    z+,temp4
       dec   temp3
       brne  StrCopy_1
StrCopy_E:ret

; temp5  -   index
Static8Copy:
       ldi   temp1,v_ui_staticstrs8
       ldi   temp2,v_ui_staticstrs8>>8
       mov   temp3,temp5
       lsl   temp3
       lsl   temp3
       lsl   temp3
       add   temp1,temp3
       adc   temp2,Null
       ldi   temp3,8
       rjmp  StrCopy

Static16Copy:
       ldi   temp1,v_ui_staticstrs16
       ldi   temp2,v_ui_staticstrs16>>8
       mov   temp3,temp5
       lsl   temp3
       lsl   temp3
       lsl   temp3
       lsl   temp3
       add   temp1,temp3
       adc   temp2,Null
       ldi   temp3,16
       rjmp  StrCopy

TrackStrCopy:
       ldi   temp1,v_ui_TrackStr      ;TRACK
       ldi   temp2,v_ui_TrackStr>>8
       ldi   temp3,8
       rjmp  StrCopy

TimeStrCopy:
       rcall BitRateGet
       lds   zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       lds   dv24uL,v_ui_bitrate
       lsr   dv24uL                ; /2
       lsr   dv24uL                ; /2
       lsr   dv24uL                ; /2
       clr   dv24uM
       clr   dv24uH
       lds   temp4,v_TrackStart
       mov   dd24uL,A0
       sub   dd24uL,temp4
       lds   temp4,v_TrackStart+1
       mov   dd24uM,A1
       sbc   dd24uM,temp4
       lds   temp4,v_TrackStart+2
       mov   dd24uH,A2
       sbc   dd24uH,temp4
       lds   temp4,v_ui_timemode
       st    z+,temp4
       cpi   temp4,'-'
       brne  TimeStrCopy_p
       lds   drem24uL,v_TrackSize
       sub   drem24uL,dd24uL
       mov   dd24uL,drem24uL
       lds   drem24uL,v_TrackSize+1
       sbc   drem24uL,dd24uM
       mov   dd24uM,drem24uL
       lds   drem24uL,v_TrackSize+2
       sbc   drem24uL,dd24uH
       mov   dd24uH,drem24uL
TimeStrCopy_p:
       rcall div24u   ;TIME
       ldi   temp4,3600
       mov   dv24uL,temp4
       ldi   temp4,3600>>8
       mov   dv24uM,temp4
       rcall div24u
       ldi   dres24uM,'0'
       add   dres24uL,dres24uM
       mov   dd24uL,drem24uL
       mov   dd24uM,drem24uM
       clr   dd24uH
       ldi   drem24uL,60
       mov   dv24uL,drem24uL
       clr   dv24uM
       rcall div24u
       ldi   dres24uH,10
       ldi   drem24uH,'0'
TimeStrCopy_1:
       cp    dres24uL,dres24uH
       brlo  TimeStrCopy_2
       sub   dres24uL,dres24uH
       inc   drem24uH
       rjmp  TimeStrCopy_1
TimeStrCopy_2:
       cpi   drem24uH,'0'
       brne  tistrcopya
       ldi   drem24uH,' '
tistrcopya:st z+,drem24uH
       ldi   drem24uH,'0'
       add   dres24uL,drem24uH
       st    z+,dres24uL
       ldi   drem24uH,'m'
       st    z+,drem24uH
       ldi   drem24uH,' '
       st    z+,drem24uH
       ldi   dres24uH,10
       ldi   drem24uH,'0'
TimeStrCopy_3:cp drem24uL,dres24uH
       brlo  TimeStrCopy_4
       sub   drem24uL,dres24uH
       inc   drem24uH
       rjmp  TimeStrCopy_3
TimeStrCopy_4:st z+,drem24uH
       ldi   drem24uH,'0'
       add   drem24uL,drem24uH
       st    z+,drem24uL
       ldi   drem24uL,'s'
       st    z+,drem24uL
       ldi   drem24uL,' '
       st    z+,drem24uL
       st    z+,drem24uL
       clr   dd24uM
       lds   dd24uL,v_ui_bitrate
       add   dd24uL,dd24uL         ; *2
       adc   dd24uM,null    ; to 320 kB/sec
GET_BR:clr   dd24uH
       rcall WR3DIGITZ
       ldi   drem24uL,'k'
       st    z+,drem24uL
       ldi   drem24uL,'B'
       st    z+,drem24uL
       ldi   drem24uL,'s'
       st    z+,drem24uL
       ret

DA_TIME:lds  zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       lds   Mc8u,END_M           ; END_M*60+END_S
       ldi   mp8u,60
       rcall MPY8u
       lds   temp4,END_S
       add   m8uL,temp4
       adc   m8uH,null
       mov   temp5,m8uH
       mov   temp6,m8ul
       lds   Mc8u,START_M         ; START_M*60+START_S
       ldi   mp8u,60
       rcall MPy8u
       lds   temp4,START_S
       add   m8uL,temp4
       adc   m8uH,null
       sub   temp6,m8uL           ; SUB END-START
       sbc   temp5,m8uH
       mov   dd24uL,temp6
       mov   dd24uM,temp5
       mov   dd24uH,null
       ldi   temp5,60              ;/60
       mov   dv24uL,temp5
       mov   dv24uM,null
       mov   dv24uH,null
       rcall div24u
       mov   temp5,dres24uL       ; Length  min.
      ;sts   LEN_S,drem24uL       ;         sec.
       ldi   temp1,'C'
       st    z+,temp1
       ldi   temp1,'D'
       st    z+,temp1
       st    z+,temp1
       ldi   temp1,'A'
       st    z+,temp1
       ldi   temp1,' '
       st    z+,temp1
       mov   temp1,temp5
      ;lds   temp1,LEN_M
       rcall BIN2BCD
       cpi   temp2,'0'            ; delete  ->00
       brne  spa_1
       ldi   temp2,' '
spa_1: st    z+,temp2
spa_2: st    z+,temp1
       ldi   temp1,':'
       st    z+,temp1
spa_3: mov   temp1,drem24uL
    ;  lds   temp1,LEN_S
       rcall BIN2BCD
       st    z+,temp2
       st    z+,temp1
       ldi   temp1,' '
       st    z+,temp1
       lds   temp1,POS_M
       rcall BIN2BCD
       cpi   temp2,'0'
       brne  spa_4
       ldi   temp2,' '
spa_4: st    z+,temp2
       st    z+,temp1
       ldi   temp1,':'
       st    z+,temp1
       lds   temp1,POS_S
       rcall BIN2BCD
       st    z+,temp2
       st    z+,temp1
       ret

       ;    zAddr         -  Dest
       ;    temp3         -  Size
       ;    temp5 / temp6 -  Text

ScrollStrCopy: lds  temp1,v_UI_LastTxt
       lds   temp2,v_UI_LastTxt+1
       cp    temp1,temp2
       breq  ScrollStrCopy_1
       sts   v_UI_ScrollOfs,Null
       sts   v_UI_LastTxt+1,temp1
ScrollStrCopy_1:ldi temp2,16
       lds   temp4,v_UI_ScrollOfs
ScrollStrCopy_4:push temp5
       push  temp6
       add   temp5,temp4
       adc   temp6,Null
       sub   temp5,zAddrL
       sbc   temp6,zAddrH
ScrollStrCopy_2:add zAddrL,temp5
       adc   zAddrH,temp6
       ld    temp1,z
       sub   zAddrL,temp5
       sbc   zAddrH,temp6
       cp    temp4,temp3
       brsh  ScrollStrCopy_3
       st    z+,temp1
       inc   temp4
       dec   temp2
       breq  ScrollStrCopy_E
       rjmp  ScrollStrCopy_2
ScrollStrCopy_3:ldi temp1,' '
       cpi   temp3,17
       brsh  ScrollStrCopy_5
ScrollStrCopy_6:st  z+,temp1
       dec   temp2
       breq  ScrollStrCopy_E
       rjmp  ScrollStrCopy_6
ScrollStrCopy_5:subi temp3,-3
ScrollStrCopy_7:st  z+,temp1
       inc   temp4
       dec   temp2
       breq  ScrollStrCopy_Er
       cp    temp4,temp3
       brsh  ScrollStrCopy_8
       rjmp  ScrollStrCopy_7
ScrollStrCopy_8:subi temp3,3
       clr   temp4
       pop   temp6
       pop   temp5
       rjmp  ScrollStrCopy_4
ScrollStrCopy_Er:subi temp3,3
ScrollStrCopy_E:lds temp4,v_UI_ScrollOfs
       inc   temp4
       cpi   temp3,17
       brlo  ScrollStrCopy_No
       subi  temp3,-3
       cp    temp4,temp3
       brlt  ScrollStrCopy_En
ScrollStrCopy_No:clr temp4
ScrollStrCopy_En:pop temp6
       pop   temp5
       sts   v_UI_ScrollOfs,temp4
ScrollStrCopy_Tx:ret

;      temp6   -   dB*2
;      Carry   -   Sign

dBStrCopy:ldi temp5,' '  ;DB
       BRCC  dBStrCopy_Pos
       ldi   temp5,'-'
dBStrCopy_Pos:ldi  temp2,'0'
       lsr   temp6
       BRCC  dBStrCopy_0
       ldi   temp2,'5'
dBStrCopy_0:mov dd24uL,temp6
       ldi   temp3,10
       mov   dv24uL,temp3
       rcall div8u
       ldi   temp3,'0'
       add   dres24uL,temp3
       cp    dres24uL,temp3
       brne  dBStrCopy_1
       mov   dres24uL,temp5
       ldi   temp5,' '
dBStrCopy_1:st z+,temp5
       st    z+,dres24uL
       add   drem24uL,temp3
       st    z+,drem24uL
       ldi   temp1,','
       st    z+,temp1
       st    z+,temp2
       ldi   temp1,' '
       st    z+,temp1
       ldi   temp1,'d'
       st    z+,temp1
       ldi   temp1,'B'
       st    z+,temp1
       ret

WR3DIGITZ:ldi  drem24uL,100
       mov   dv24uL,drem24uL
       clr   dv24uM
       clr   dv24uH
       rcall div24u
       ldi   drem24uM,'0'
       add   dres24uL,drem24uM
       push  dres24uL           ;! store
       cpi   dres24uL,'0'
       brne  skipd1
       ldi   dres24uL,' '       ; remove empty 0
skipd1:st    z+,dres24uL
       mov   dd24uL,drem24uL
       clr   dd24uM
       clr   dd24uH
       ldi   drem24uL,10
       mov   dv24uL,drem24uL
       rcall div24u
       ldi   drem24uM,'0'
       add   dres24uL,drem24uM
       pop   drem24uH           ; !!!  mov drem24uH,dres24uL !!!
       cpi   drem24uH,'0'       ; remove empty 0
       brne  skipd2
       cpi   dres24uL,'0'
       brne  skipd2
       ldi   dres24uL,' '
skipd2:add   drem24uL,drem24uM
       st    z+,dres24uL
       st    z+,drem24uL
       ret

display_time:sbrc  StateFlags,fs_Autrack
       rjmp  DIS_TIME1
       rcall timestrcopy
       ret

DIS_TIME1:rcall DA_TIME
       ret

display_title:lds  zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       sts   v_UI_LastTxt,temp5          ; temp5 display mode
       ldi   temp5,(v_TrackInfo+o_Name)
       ldi   temp6,(v_TrackInfo+o_Name)>>8
       lds   temp3,o_NameSize+v_TrackInfo
       rjmp  display_strscroll
display_artist:lds zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       sts   v_UI_LastTxt,temp5
       ldi   temp5,(v_TrackInfo+o_Artist)
       ldi   temp6,(v_TrackInfo+o_Artist)>>8
       lds   temp3,o_ArtistSize+v_TrackInfo
       rjmp  display_strscroll
display_album: lds  zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       sts   v_UI_LastTxt,temp5
       ldi   temp5,(v_TrackInfo+o_Album)
       ldi   temp6,(v_TrackInfo+o_Album)>>8
       lds   temp3,o_AlbumSize+v_TrackInfo
       rjmp  display_strscroll
display_comment:lds zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       sts   v_UI_LastTxt,temp5
       ldi   temp5,(v_TrackInfo+o_Comment)
       ldi   temp6,(v_TrackInfo+o_Comment)>>8
       lds   temp3,o_CommentSize+v_TrackInfo
       rjmp  display_strscroll
display_file:lds  zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       sts   v_UI_LastTxt,temp5
       ldi   temp5,(v_TrackInfo+o_FilePath+1)
       ldi   temp6,(v_TrackInfo+o_FilePath+1)>>8
       lds   temp3,o_FilePath+v_TrackInfo
       subi  temp3,2     ;!!
       rjmp  display_strscroll

display_trackselect:lds zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       ldi   temp5,ui_str8_track
       rcall static8Copy
       lds   dd24uL,v_ui_tracksel
       lds   dd24uM,v_ui_tracksel+1
       clr   dd24uH
       rcall WR3DIGITZ
       ldi   temp1,13
       rcall SpaceCopy
       rjmp  display_end
display_Volume:lds zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       rcall Space8Copy
       lds   temp6,v_VolumeIndex
       add   temp6,temp6
       SEC
       rcall dbStrCopy
       rjmp  display_end

display_BTx3:tst  temp6
       BRPL  display_BTx3_Pos
       NEG   temp6
       mov   temp5,temp6
       lsl   temp6
       add   temp6,temp5
       SEC
       ret
display_BTx3_Pos:mov temp5,temp6
       lsl   temp6
       add   temp6,temp5
       ret

display_Bass:lds  zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       rcall Space8Copy
       lds   temp6,v_BassIndex
       rcall display_BTx3
       rcall dbStrCopy
       rjmp  display_end
display_Treble:lds  zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       rcall Space8Copy
       lds   temp6,v_TrebleIndex
       rcall display_BTx3
       rcall dbStrCopy
       rjmp  display_end
display_Pitch:lds  zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       ldi   temp1,4
       rcall SpaceCopy
       lds   temp6,v_PitchIndex
       ldi   temp1,'+'
       cp    temp6,Null
       BRPL  display_pitch_1
       ldi   temp1,'-'
       NEG   temp6
display_pitch_1:st  z+,temp1
       mov   dd24uL,temp6
       clr   dd24uM
       clr   dd24uH
       rcall WR3DIGITZ
       ldi   temp1,8
       rcall SpaceCopy
       rjmp  display_end

display_PlayMode:lds zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       lds   temp5,v_PlayMode
       rcall Static16Copy
       rjmp  display_end

display_ListSelect:lds zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       ldi   temp5,3
       rcall Static16Copy
       rjmp  display_end

display_LightMode:lds zAddrL,v_ui_zSave
       lds   zAddrH,v_ui_zSave+1
       lds   temp5,v_ui_State
       andi  temp5,3
       subi  temp5,-4
       rcall Static16Copy
       rjmp  display_end

display_strscroll:rcall  ScrollStrCopy
display_end:   ret

Space8Copy:    ldi  temp1,8
SpaceCopy:     ldi  temp2,' '
Space8Copy_1:  st   z+,temp2
               dec  temp1
               brne Space8Copy_1
               ret

;--------------------------< command procs >

CMD_NONE: sts  v_UARTInCount,Null
          cbr  Flags,(1<<f_cmdWaiting)
CMD_END:  rjmp UIProc_E

BitRateGet:
       rcall i2c_init
       ldi   i2cadr,0x86+i2cwr
       rcall i2c_start
       ldi   i2cdata,0x6A
       rcall i2c_write
       rcall i2c_stop
       ldi   i2cadr,0x86+i2crd
       rcall i2c_start
       rcall i2c_read
       mov   pmreg,i2cdata
       sts   v_ui_bitrate,pmreg
       lsr   pmreg
       lsr   pmreg
       lsr   pmreg
       rcall i2c_stop
       ret

div24u:clr  drem24uL
       clr  drem24uM
       sub  drem24uH,drem24uH
       ldi  dcnt24u,25
d24u_1:rol  dd24uL
       rol  dd24uM
       rol  dd24uH
       dec  dcnt24u
       brne d24u_2
       ret
d24u_2:rol  drem24uL
       rol  drem24uM
       rol  drem24uH
       sub  drem24uL,dv24uL
       sbc  drem24uM,dv24uM
       sbc  drem24uH,dv24uH
       brcc d24u_3
       add  drem24uL,dv24uL
       adc  drem24uM,dv24uM
       adc  drem24uH,dv24uH
       clc
       rjmp d24u_1
d24u_3:sec
       rjmp d24u_1
div8u: sub  drem24uL,drem24uL
       ldi  dcnt24u,9
d8u_1: rol  dd24uL
       dec  dcnt24u
       brne d8u_2
       ret
d8u_2: rol  drem24uL
       sub  drem24uL,dv24uL
       brcc d8u_3
       add  drem24uL,dv24uL
       clc
       rjmp d8u_1
d8u_3: sec
       rjmp d8u_1

mpy10: mov  temp5,temp1
       mov  temp6,temp2
       CLC
       ldi  temp3,3
mpy10_1:rol temp5
       rol  temp6
       dec  temp3
       brne mpy10_1
       add  temp5,temp1
       adc  temp6,temp2
       add  temp5,temp1
       adc  temp6,temp2
       ret

BIN2BCD: clr  temp2         ; IN temp1=BIN
         ldi  temp3,0x30
b2bcd8_1:subi temp1,10      ; OUT temp2=MSD
         brcs B2BCD8_2      ; temp1=LSD
         inc  temp2
         rjmp B2BCD8_1
B2BCD8_2:subi temp1,-10
         add  temp1,temp3
         add  temp2,temp3    ; Bcd to DEC
         ret

;***** Subroutine Register Variables
;.def       mc8u =r16     ; multiplicand
;.def       mp8u =r17     ; multiplier
;.def       m8uL =r17     ; result   Low byte
;.def       m8uH =r18     ; result   High     byte

mpy8u:clr m8uH
     lsr  mp8u
     brcc noad80
     add  m8uH,mc8u
noad80:ror  m8uH
     ror  m8uL
     brcc noad81
     add  m8uH,mc8u
noad81:ror  m8uH
     ror  m8uL
     brcc noad82
     add  m8uH,mc8u
noad82:ror  m8uH
     ror  m8uL
     brcc noad83
     add  m8uH,mc8u
noad83:ror  m8uH
     ror  m8uL
     brcc noad84
     add  m8uH,mc8u
noad84:ror  m8uH
     ror  m8uL
     brcc noad85
     add  m8uH,mc8u
noad85:ror  m8uH
     ror  m8uL
     brcc noad86
     add  m8uH,mc8u
noad86:ror  m8uH
     ror  m8uL
     brcc noad87
     add  m8uH,mc8u
noad87:ror  m8uH
     ror  m8uL
     ret
;---------------------< command jump table >
TRINFOFSTAB:
       .DW  o_Name
       .DW  o_NameSize
       .DW  o_Artist
       .DW  o_ArtistSize
       .DW  o_Album
       .DW  o_AlbumSize
       .DW  o_Comment
       .DW  o_CommentSize

; internal code jump table,IR  codes are mapped to this table
IRCMDTAB:rjmp ICMD_PLAY         ;Code  1 No IR Code!!
         rjmp ICMD_STOP         ;Code  2 (IR & KEY CODE TABLE)
         rjmp ICMD_PAUSE        ;Code  3
         rjmp ICMD_VOL_UP       ;Code  4
         rjmp ICMD_VOL_DOWN     ;Code  5
         rjmp ICMD_TRACK_FWD    ;Code  6
         rjmp ICMD_TRACK_BWD    ;Code  7
         rjmp ICMD_FWD          ;Code  8
         rjmp ICMD_BWD          ;Code  9
         rjmp ICMD_MUTE         ;Code  A
         rjmp ICMD_DISPLAY      ;Code  B
         rjmp ICMD_SETUP        ;Code  C
         rjmp ICMD_ENTER        ;Code  D
         rjmp ICMD_CANCEL       ;Code  E
         rjmp ICMD_EJECT        ;Code  F
         rjmp ICMD_0            ;Code  10
         rjmp ICMD_1            ;Code  11
         rjmp ICMD_2            ;Code  12
         rjmp ICMD_3            ;Code  13
         rjmp ICMD_4            ;Code  14
         rjmp ICMD_5            ;Code  15
         rjmp ICMD_6            ;Code  16
         rjmp ICMD_7            ;Code  17
         rjmp ICMD_8            ;Code  18
         rjmp ICMD_9            ;Code  19
         rjmp ICMD_SKIP10f      ;Code  1A
         rjmp ICMD_SKIP10b      ;Code  1B
         rjmp ICMD_SNAP         ;Code  1C
         rjmp ICMD_SKIP50B      ;Code  1D
         rjmp ICMD_SKIP50F      ;Code  1E
         rjmp ICMD_REPEAT       ;Code  1F

DISPCMDTAB:rjmp display_time    ; Code 0
       rjmp display_file        ; Code 6
       rjmp display_title       ; Code 2
       rjmp display_artist      ; Code 3
       rjmp display_album       ; Code 4
       rjmp display_comment     ; Code 5
       rjmp display_time        ; Code 7
       rjmp display_file        ; Code 8
       rjmp display_trackselect ; Code 9
       rjmp display_Volume      ; Code A
       rjmp display_Bass        ; Code B
       rjmp display_Treble      ; Code C
       rjmp display_Pitch       ; Code D
       rjmp display_PlayMode    ; Code E
       rjmp display_ListSelect  ; Code F
       rjmp display_LightMode   ; Code 10

DISPLAYTIMES:  .DB  10,10,10,10,10,10

i2c_hp_delay:
     ldi  i2cdelay,30      ;    25
i2c_hp_delay_loop:
     dec  i2cdelay
     brne i2c_hp_delay_loop
     ret
i2c_qp_delay:
     ldi  i2cdelay,15      ;    15
i2c_qp_delay_loop:
     dec  i2cdelay
     brne i2c_qp_delay_loop
     ret
i2c_rep_start:
     sbi   DDRB,SCLP       ; force SCL low
     cbi   DDRB,SDAP       ; release SDA
     rcall i2c_hp_delay    ; half   period delay
     cbi   DDRB,SCLP       ; release SCL
     rcall i2c_qp_delay    ; quarter period delay
i2c_start:
     mov   i2cdata,i2cadr  ; copy address to  transmitt register
     sbi   DDRB,SDAP       ; force SDA low
     rcall i2c_qp_delay    ; quarter period delay
i2c_write:
     sec                   ; set  carry   flag
     rol  i2cdata          ; shift in carry and out bit one
     rjmp i2c_write_first
i2c_write_bit:
     lsl  i2cdata          ; if   transmit register   empty
i2c_write_first:
     breq i2c_get_ack      ; goto get  acknowledge
     sbi  DDRB,SCLP        ; force SCL low
     brcc i2c_write_low    ; if   bit high
     nop                   ; (equalize number of cycles)
     cbi  DDRB,SDAP        ; release SDA
     rjmp i2c_write_high
i2c_write_low:             ;   else
     sbi  DDRB,SDAP        ; force   SDA low
     rjmp i2c_write_high   ; (equalize number of cycles)
i2c_write_high:
     rcall i2c_hp_delay    ; half   period delay
     cbi   DDRB,SCLP       ; release SCL
     rcall i2c_hp_delay    ; half   period delay
     rjmp  i2c_write_bit
i2c_get_ack:
     sbi   DDRB,SCLP       ; force SCL low
     cbi   DDRB,SDAP       ; release SDA
     rcall i2c_hp_delay    ; half   period delay
     cbi   DDRB,SCLP       ; release SCL
i2c_get_ack_wait:
     sbis  PINB,SCLP       ; wait  SCL high
     rjmp  i2c_get_ack_wait; (In case wait states are inserted)
     clc                   ; clear   carry flag
     sbic  PINB,SDAP       ; if SDA is high
     sec                   ; set carry  flag
     rcall i2c_hp_delay    ; half   period delay
     ret
i2c_do_transfer:
     sbrs i2cadr,b_dir     ; if   dir = write
     rjmp i2c_write        ; goto   write data
i2c_read:
     rol  i2cstat          ; store acknowledge;  (used by i2c_put_ack)
     ldi  i2cdata,0x01     ; data   =  0x01
     sbi  DDRB,SCLP
     cbi  DDRB,SDAP
i2c_read_bit:              ; do
     sbi   DDRB,SCLP       ; force    SCL  low
     rcall i2c_hp_delay    ; half   period delay
     cbi   DDRB,SCLP       ; release  SCL
     rcall i2c_hp_delay    ; half   period delay
     clc                   ; clear carry flag
     sbic  PINB,SDAP       ; if SDA is high
     sec                   ; set carry flag
     rol   i2cdata         ; store  data bit
     brcc  i2c_read_bit    ; while receive register   not full
i2c_put_ack:
     sbi  DDRB,SCLP        ; force SCL low
     ror  i2cstat          ; get   status bit
     brcc i2c_put_ack_low  ; if  bit low  goto assert   low
     cbi  DDRB,SDAP        ; release  SDA
     rjmp i2c_put_ack_high
i2c_put_ack_low:           ;   else
     sbi  DDRB,SDAP        ; force    SDA  low
i2c_put_ack_high:
     rcall i2c_hp_delay    ; half   period delay
     cbi   DDRB,SCLP       ; release SCL
i2c_put_ack_wait:
     sbis  PINB,SCLP       ; wait   SCL high
     rjmp  i2c_put_ack_wait
     rcall i2c_hp_delay    ; half   period delay
     ret
i2c_stop:
     sbi   DDRB,SCLP       ; force SCL low
     sbi   DDRB,SDAP       ; force SDA low
     rcall i2c_hp_delay    ; half   period delay
     cbi   DDRB,SCLP       ; release SCL
     rcall i2c_qp_delay    ; quarter period         delay
     cbi   DDRB,SDAP       ; release SDA
     rcall i2c_hp_delay    ; half   period delay
     ret
i2c_init:
     cbi  PORTB,SCLP
     cbi  PORTB,SDAP
     clr  i2cstat
     ret

.def EEdrd     =r0         ; result data byte
.def EEard     =r30        ; address low to read from
.def EEardh    =r31        ; address high to read from

EERead:
     sbic EECR,EEWE        ; if EEWE not clear
     rjmp EERead           ; wait more
     out  EEARH,EEardh     ; output address high for 8515
     out  EEARL,EEard      ; output address  low for 8515
     sbi  EECR,EERE        ; set EEPROM Read strobe
     ;This instruction takes 4 clock cycles since
     ;it  halts the CPU for two clock cycles
     in   EEdrd,EEDR       ; get  data
     ret

.def EErtmp    =r30        ; temporary storage of low  address
.def EErtmph   =r31        ; temporary storage of high address
.def EEdrd_s   =r0         ; result data byte

EERead_seq:
     sbic EECR,EEWE        ; if EEWE not clear
     rjmp EERead_seq       ; wait more
     in   EErtmp,EEARL     ; get address low     8515
     in   EErtmph,EEARH    ; get address high    8515
     adiw EErtmp,0x01      ; increment   address 8515
     out  EEARL,EErtmp     ; output  address     8515
     out  EEARH,EErtmph    ; output  address     8515
     sbi  EECR,EERE        ; set EEPROM Read strobe
     ;This instruction takes 4 clock cycles  since
     ;it halts the CPU for two clock cycles
     in   EEdrd_s,EEDR     ; get data
     ret

STA_PMseqW:ldi  i2cadr,0x86+i2cwr
       lpm
       mov  temp1,PMreg
STA_PMseqW_1:adiw  zAddrL,1
       lpm
       ldi   i2cadr,0x86+i2cwr
       rcall i2c_start
       mov   i2cdata,PMreg
       rcall i2c_do_transfer
       adiw  zAddrL,1
       lpm
       mov   i2cdata,PMreg
       rcall i2c_do_transfer
       rcall i2c_stop
       dec   temp1
       brne  STA_PMseqW_1
       ret

STA_EEseqW:ldi i2cadr,0x86+i2cwr
       rcall EERead
       mov   temp1,PMreg
STA_EEseqW_1:rcall EERead_seq
       ldi   i2cadr,0x86+i2cwr
       rcall i2c_start
       mov   i2cdata,PMreg
       rcall i2c_do_transfer
       rcall EERead_seq
       mov   i2cdata,PMreg
       rcall i2c_do_transfer
       rcall i2c_stop
       dec   temp1
       brne  STA_EEseqW_1
       ret

      .eseg         ; !

I2Cseq_INIT_EE:
       .DB 0x17               ; POCET DVOJPRIKAZU
       .DB 0x54,0x03          ; PCM DIVIDER 16 BIT MODE 256*FS(0x03)
       .DB 0x55,0x00          ; PCMCONF 0010 0010 !orig
                              ; B6=0=PCM ORDER = MSB  FIRST
                              ; B5=1=WORD  LEFT PaddED
                              ; B4=0=LRCLK POL COMPL I2S
                              ; B3=0=I2S FORMAT
                              ; B2=0=FALLING EDGE SCKT    !!!
                              ; 10 = 20 BIT MODE , 00 16 BIT MODE
       .DB 0x63,0x00          ; DAC_CLK  MODE OCLK  CAN BE  CHANGED
       .DB 0x06,0x16          ; PLLCTL CONFIG PLL DSP DEF.0X0C
       .DB 0x0B,0x03          ; ???  RESERVED ,RST VAL 3
       .DB 0x65,0x0A          ; PLLFRAC_H
       .DB 0x52,0xFD          ; PLLFRAC441_H
       .DB 0x64,0x3D          ; PLLFRAC_L
       .DB 0x51,0x8B          ; PLLFRAC_441_L
       .DB 0x50,0x10          ; MFSDF_441
       .DB 0x61,0x0E          ; MFSDF   (X)
       .DB 0x05,0xA1          ; PLLCTL 20:16
       .DB 0x0D,0x04          ; SCLK_POL SDI ARE SENT RIS.EDGE OF SCKR
                              ; SAMPLED OF THE FALLING EDGE
       .DB 0x18,0x04          ; DATA_REQ_EN REQUEST  SIGNAL - MULTIMEDIA MODE
       .DB 0x0C,0x01          ; REQ_POL DREQ = H
       .DB 0x72,0x01          ; RUN  = START DEC.
       .DB 0x46,0x0A          ; DLA    0x00  LEFT  AUDIO - 0X0A dB
       .DB 0x48,0x0A          ; DRA    0x00  RIGHT AUDIO

; BASS FREQ <= TREBLE FREQ AND BASS FREQ > 0
; TREBLE_HIGH   TREBLE_LOW
; 0x07          0xD0  =  2000 Hz
; BASS_HIGH     BASS_LOW
; 0x00          0x64  =  100 Hz
; HEX.PARAMETR PRIMO UDAVA KMITOCET V Hz

       .DB 0x78,0x07          ; TREBLE HIGH
       .DB 0x77,0xD0          ; TREBLE LOW
       .DB 0x79,0x64          ; BASS   LOW
       .DB 0x7A,0x00          ; BASS   HIGH
       .DB 0x7D,0x04          ; TONE   ATTEN  - 4 * 1.5 dB TJ -6 dB


mel_Spaces:  .DB "                                "
mel_NO_CD:   .DB "No CD - Eject ?                 "
mel_No_Track:.DB "No Audio or MP3 track$ - Eject ?"
mel_CD_Stop: .DB "CD Stopped - - -         Eject ?"
mel_CD_Load: .DB "CD Loading ...           Wait.. "
mel_CD_Eject:.DB "CD Ejected !!!            Load ?"
;                         9       N/L    |










